*** If you want to know full changes, please read 000_gitlog.txt and history.txt. ***

* SNAPSHOT August 01, 2021
  * Upstream 2021-05-02.
  * [BUILD/CMAKE] Add *Very Experimental* C++20 build settings.
  * [OSD/EMU][MOUSE/JOYSTICK] Should LOCK/UNLOCK per referring buffers of joystick/mouse.
    Note: This is MAJOR API CHANGE around mouse and joystick.
  * [CONFIG/FMTOWNS] Add config.machine_features[32] to use machine configuration (w/o DIP SWITCH).Still not be bulidable.
    Note: See vm/fmtowns/joystick.cpp, FMTOWNS::JOYSTICK::update_config().
  * [FMTOWNS/KEYBOARD] SPECIAL_RESET: Available to boot with special key code (i.e. "CD" "DEBUG").
  * [FMTOWNS/CDROM] Re-implement parsing CCD image file.Still ugly.
  * [FMTOWNS/VRAM] Add __LIKELY_IF() and __UNLIKELY_IF() to assist compiler's optimization.
    See [read|write]_memory_mapped_io32() and read_memory_mapped_io16() at FMTOWNS::TOWNS_VRAM class.
  * [VM/I386_NP21] Add hints of branch-prediction whether accessing memory (and some of interrupts) is legal.
    This reduces HOST CPU USAGE especially high-VM-clocks.
  * [FMTOWNS/VRAM] More faster vram accessing.
  * [FMTOWNS/MEMORY/VRAM] Add features around CACHE for after i486.Still be dummy.
  * [FMTOWNS/CRTC] Use more SIMDs to be faster rendering.
  * [FMTOWNS/KEYBOARD] Implement AUTO REPEAT.
  * [FMTOWNS/TIMER] Clear OV and INTR when enabling interval timer.
  * [FMTOWNS/VRAM] More faster VRAM access for packed pixel mode.
  * [FMTOWNS/CDROM] Even reply without REQ_STATUS bit (0x20) with PAUSE/RESUME CDDA (85h/87h).
  * [FMTOWNS/CDROM] Falldown intr even stat_reply_intr (04C2:bit6) == 0 on MCU interrupt.
  * [FMTOWNS/CDROM] Reply error when reading beyond track on READ_SECTOR.
  * [FMTOWNS/CDROM] Fix around booting from some version(s?) of TOWNS OS.
	 i.e)AYAYO 4.
  * [FMTOWNS/CRTC/TIMER/MEMORY] Improve around I/O.
  * [FMTOWNS/DMAC] Remove some variables.Update state save version.
  * [FMTOWNS/SCSI] Add a PORT: 0C34h.
  * [FMTOWNS/MEMORY] Revert to use primitive_[read|write]. Fix CDROM's some issues (i.e. Crashing Ayayo4).
  * [FMTOWNS/MEMORY] Add dma read/write functions with wait.
  * [FMTOWNS/ICCARD] Improve logic around open/close.
  * [FMTOWNS/JOYSTICK] Fix confused mouse mask.
  * [FMTOWNS] Split MOUSE and JOYPADs to separate class.
  * [FMTOWNS/FLOPPY] Add support for 1.44MB 2HD (2HC).
  * [I286/I86/V30] Separate namespace CPUTYPE ENUMS.
  * [I286/I86] Fix weird bitmask default value.
  * [VM/UPD71071] Add read_io16(), write_io16() and ACK feature.
  * [PC9801/EGC] Fix FTBFS with C++20 ; "error: ISO C++17 does not allow 'register' storage class specifier".
  * [BUILD/CMake] Add samplescripts supports GCC-11 initially.
  * [BUILD/CMake] Prepare to support LLVM12, but now unable to build Win32 version with llvm12 due to _aligned_alloc() and _aligned_free().
  * [Build/Win32] LLVM12/MinGW-w64/Cross : Add libc++abi and others to toolchain.
  * [Build/Win32] Update revision of ffmpeg to 4.4.
  * [JOY_THREAD/SDL2/GAMECONTROLLER] Fix sample initial value.
  * Built with ab2601af3b0de22bd806ce5312ebf06823a16405 (or later).

-- Aug 01, 2021 22:34:13 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT December 16, 2020
  * Upstream 2020-08-16.
  * Important: Build system moved to CMake *perfectly*.See INSTALL.md or INSTALL.en.md.
  * eFM-Towns: Works more softwares.See 00_status_ja.md .
  * [Qt/JOYSTICK] Add mapping gamecontroller settings.
	Read from $CONFIG_DIR/joydb.ini as SDL_GAMECONTROLLER format.
	See https://wiki.libsdl.org/SDL_GameControllerAddMapping .
  * [VM/I386_NP21] Improve CPU registers message.
  * [VM/I386_NP21] Print PC address on PANIC.
  * [VM/DEVICE] Add APIs to DEVICE::; clear_event(), force_register_event(), check_and_update_event() and variants.
  * [VM/FMTOWNS] CDROM: Implement around commands.
  * [VM/FMTOWNS] CDROM: Fix around command 80h (SET STATE).May work RANCE III and SUPER REAL MAHJONG PIV.
  * [VM/FMTOWNS] CDROM: Command A0h: TOWNS_CD_ACCEPT_WAIT must be only after CDROM_COMMAND_STOP_CDDA.
  * [VM/FMTOWNS] CDROM: Reply status immediately with PLAY/PAUSE/UNPAUSE without STATUS BIT (44h/C5h/C7h).
  * [VM/FMTOWNS] CDROM: Maybe working with CCD image.
  * [VM/FMTOWNS] CDROM: Rename delay/status methods to unique name.
  * [VM/FMTOWNS] CDROM: Don't occure duplicated EOT.
  * [VM/FMTOWNS] CDROM: Fix not play CDDA with command SPAM.
  * [VM/FMTOWNS] CDROM: Fix wrong sector size with single track.
  * [VM/FMTOWNS] CDROM: Implement ISO file feature, MODE1/2/RAW read feature.
  * [VM/FMTOWNS] CDROM: Fix wrong response at PAUSE/RESUME CDDA (85h/87h).
  * [VM/FMTOWNS] SPRITE: Fix around zooming and rotating.
  * [VM/FMTOWNS] CRTC: Available to display LOW RESOLUTION.
  * [VM/FMTOWNS] MEMORY: Disable shadow write at F8000h-FFFFFh.
  * [VM/FMTOWNS] MEMORY: Reset memory map when reset from CPU (i.e.Triple fault).
  * [VM/FMTOWNS] SPRITE: Implement correct offset handling and clipping feature.
  * [VM/FMTOWNS] SPRITE: Event driven sprite.
  * [VM/FMTOWNS] VRAM: TRY: Don't wrap around boundary of VRAM (i.e.8107ffff).
  * [VM/UPD71071] eFM-Towns works without SINGLE_MODE_DMA.
  * [VM/UPD71071/TOWNS_DMAC] Add debug message for issues, i.e.Bubble Bobble for FM-Towns.
  * [VM/UPD71071/TOWNS_DMAC] More correctness addressing on R/W.
  * [VM/FM7] DISPLAY: Optimize to be faster.
  * [VM/FM7] DISPLAY: Adjust alignment of some variables.
  * [VM/FM7] MAINMEM: Fix crash at DISPLAY::initialize().
             Seems to break memory at FM7_MAINMEM::initialize().
  * [VM/FM7] MAINMEM: Fixing MEMORY LEAK.
  * [VM/FM7] DISPLAY: Fix not resume digital palette on loading state.
  * [VM/PCM1BIT][COMMON] Fix memory access violation in high-pass/low-pass filter.
  * [VM/MB8877] Fix memory leak on state saving/loading.
  * [VM/COMMON_VM] Move AD78820KR::, RF6C68::, YM2612:: to libCSPcommon_vm.
  * [VM] Make event() and mix() (and some functions) with __FASTCALL.
  * [EMU/Qt] Block execution EMU until prepering GUIs.
  * [EMU/Qt] Don't out LOG until logger set up.
  * [Qt/Draw] DO not start thread at Ui_MainWindow::LaunchEmuThread().
  * [Qt/OSD] Inherit OSD_BASE to QObject.Maybe not needed threading.
  * [Qt/EMU] MOVE a lot of methods to EMU_TEMPLATE:: and EmuThreadClassBase::.
  * [UI/Qt] MOUSE: Add mouse sensitivities config GUI.
  * [UI/Qt] Integrate to single MainWindow object.
            Fix https://matsuri.5ch.net/test/read.cgi/i4004/1601147054/80 .
  * [UI/Qt] Add confirm on quitting emulator.
  * [Qt/LOGGER] Add mutex locking to some functions called from logger.
                Fix crash on quitting a emulator.
  * [UI/Qt] Change orders of "Emulator Menu".
  * [Qt/MOUSE] Fix mouse clicking on one-board-computers.
  * [COMMON] Make method of pairXX_t with __FASTCALL.
  * [UI/Qt] FLOPPY: Use 5inch icon when using 5inch floppy.
  * [OSD/Qt] Fix using pointer after freeing.
  * [DOC] Add INSTALL.md and INSTALL.en.md.
  * [NET/Qt] Re-implement around TCP/IP, UDP/IP.MZ-2500 works.
  * [Qt/OpenGL] SHADER: Stop to use discard.
  * [Qt/OpenGL] Make shaders abstraction.
  * [Qt/OpenGL 4.5] Reduce create/destroy buffers at same screen size.
  * [Qt/OpenGL4_5] Fix around TV-Rendering.
  * [QT/OpenGL4.5] Prepare to implement screen distortion.
  * [Qt/OpenGL] Integrate shaders beyond GL version and GL/GLES.
  * [UI/Qt] Fix not update around virtual media display.
  * [UI/Qt] Fix not found disk file include kanji (or another non-latin character)
             as filename.This issue maybe happen at non-UTF-8 locale.
  * [Qt/COMMAND_LINE] Fix failure starting args "--fdx" "--bubx" with  D88/D77/B77 file.
                      Maybe fixed https://matsuri.5ch.net/test/read.cgi/i4004/1601147054/30 .
  * [BUILD/CMAKE] Support multiarch LIBDIR.
	          Maybe fixed https://matsuri.5ch.net/test/read.cgi/i4004/1601147054/21-24.
  * [BUILD/CMAKE] Try to resolve https://matsuri.5ch.net/test/read.cgi/i4004/1601147054/33.
  * [BUILD/Win32] Make CSPcommon_vm DLL.
  * [BUILD/CMAKE] FORCE SET C++ STANDARD to C++11.
  * [TOOLCHAIN/WIN32] Update cross-build X264 script.
  * [TOOLCHAIN/WIN32] Update cross building scripts for some external libraries.
  * Built with 46662e26995354caf47739a7723cd5b96dc67a26 (or later).

-- Dec 16, 2020 00:40:21 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT September 26, 2020
 * Upstream 2020-04-06.
 * [FMTOWNS/DMAC] Bootable TownsOS v1.1L30 based softwares.
                  Fix around DMA address mask.
		  See source/src/vm/fmtowns/00_status.ja.md.
 * [General] Now, version of all DLLs/SOLIBs are 3.0.x.		  
 * [DEVICE] Change API: special_reset(num).
            This aimes to support FM-Towns's multiple special resetting.
 * [I18N] Prepare to support multiple languages.
 * [Draw/GL4_5] Wait until complete to mapping.
                Fix crash with QUAZZLE (FMTOWNS;FSW Collection 10).
 * [VM/FMTOWNS][OOPs] Fix fallthroughs.
 * [VM/FMTOWNS] Add IC CARD feature.
 * [FMTOWNS/CRTC] More simple logic at rendering.
 * [FMTOWNS/CDROM] RESTORE/SEEK COMMAND (00h) must seek to lba0, then aimed lba.
 * [FMTOWNS/CDROM] PAUSE COMMAND (85h) : Return extra status even isn't audio track.
 * [FMTOWNS/CDROM] READ MODE1: May not need extra status, integrated after reading.
 * [FMTOWNS/MEMORY] Integrate memory accessing to primitive inline functions.
 * [FMTOWNS/CDROM][WIP] Status around CMD A0h. This is working-in-progress.
 * [FMTOWNS/CDROM][WIP] TRY: Implement PIO transfer.
 * [FMTOWNS/CDROM] Should read per a sector, not variable length.
 * [FMTOWNS/CDROM] Implement pseudo burst transfer for DMA.
 * [FMTOWNS/CDROM] Set CDDA_STATUS=CDDA_OFF before reading data.
                   Fix スーパーリアル麻雀PIV.
 * [FMTOWNS/SPRITE] Initially works.
 * [FMTOWNS/VRAM] Faster write access via write_memory_mapped_io[16|32]() .
 * [FMTOWNS/TIMER] Disable free run counter before 1H/2H/1F/2F.
 * [FMTOWNS/FLOPPY] Implement some bits and disk changed feature 
                    (0208h:bit0:R after Towns2H/2F/1H/1F).
 * [FMTOWNS/TIMER] Didable 1uS wait feature wait before xxF/xxH.
 * [FMTOWNS/KEYBOARD] TRY: Boot with 'CD' 'H0' etc.Still works only with 'DEBUG'.
 * [FMTOWNS/SCSI] Add SIG_SCSI_EOT signal.
 * [FMTOWNS/SCSI] Set ctr_reg after sending command to host.
 * [Qt/LOGGER] Fix not initialize (internal)osd_pointer;
               wish to fix below issue (@Fedora Linux) 
	       https://matsuri.5ch.net/test/read.cgi/i4004/1526806551/935
               by this.
 * [VM/I386_NP21] Memory access:Make functions inline to be faster processing.
 * [VM/COMMON_VM] Fix warining of 'set_context_intr' hides overloaded 
                  virtual function [-Woverloaded-virtual] with LLVM Clang++.
 * [VM/MC6809] Remove MC6809_BASE::, integrated to MC6809:: .
 * [VM/Z80] Remove Z80_BASE::, integrate to Z80:: .
 * [VM/UPD7220] Limit address of PSET.More correctness clock feature.
 * [VM/UPD71071] Fix tc bit down.
 * [VM/UPD71071] Add some signals.
 * [VM/UPD71071][FMTOWNS][MZ2800] Update API; Separate TC signals per a channel.
 * [VM/UPD71071] SREQ is prior than MASK.Don't auto transfer at demand mode.
 * [VM/UPD71071] Implement ENDx signal for stopping DMA from some devices.

 * [VM/I8259] Initialize registers by reset().
 * [EMU][UI/FLOPPY] Implement 1sec delayed open() for floppy, 
                    fix not detect when changing from HISTORY.
 * [X1/DRAW] Fix spending a lot of host CPU usage on draw_screen().
             This issue has happened at only X1 (not turbo) due to
             memory aligns and cache lines.
             Set alignment of RAM and some values.
 * Built with 97db8d7a26eb8eeb7722b009456d7c9bcadda0f7 (or later).

-- Sep 26, 2020 18:29:40 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT June 27, 2020
 * Upstream 2020-04-06.
 * [EMULATION] Now, emulation period is half of one frame.
               Because some devices (i.e. mouse) seems to need a short period.
               This may change to 1/4 of one frame (or not).
	       See event.cpp and qt/common/emu_thread.cpp (& more).
 * [VM/EMU] Important: now EMU:: class inherits EMU_TEMPLATE:: .
 * [VM/EVENT][Qt] execute event->drive() (or event->run()) by half frame.
                  This is workaround for choppy mouse pointer/joystick.
 * [VM/FMTOWNS] Still works initially.
                See source/src/vm/fmtowns/00_status.ja.md,
                STATUS section of doc/VMs/fmtowns.txt
		and 000_gitlog.txt .
 * [VM/FMTOWNS] CDROM: Implement CMD 00h (SEEK) correctness.
                May Fractal engine works..
 * [VM/DEVICE][DEBUGGER] Add Call trace feature to I386_NP21.
                         DEVICE::'s API HAS CHANGED.
 * [VM/DEBUGGER] Add logging to "UCT" (Call trace) command.
 * [VM][CONFIG] Add variable memory size feature to some VMs.See eFMTOWNS.
 * [Qt/OpenGL4_5] Draw: Fix crash with external mapping (immutable storage).
                        Still not implement reading buffer.
 * [COMMON/FIFO] Add FIFO::fifo_size() and FIFO::left().Update SOVERSION.
 * [BUILD/CMake] Win32: Update toolchain for LLVM10.x and Ubuntu20.04
                 (Has uploaded to
		 https://hub.docker.com/repository/docker/artanejp/mingw-w64-llvm10-ubuntu20.04/general ).
 * [BUILD/Linux] Debian Sid: Now, build with CLANG 10 and Qt5.14.
 * [VM/FMGEN][VM/YM2612][VM/FMTOWNS] Fix prescaler value, calculating for own OPN2.
 * [VM/I386_NP21] Merge Upstream 2020-04-06 's I386::/NP21.Belows are differ from upstream:
      - Make some memory access functions inline (these are bottoleneck of emulation).
      - And some modifies are same as SNAPSHOT March 03, 2020.
 * [VM/I386_NP21] Optimise for speed, make some functions __inline__ .
 * [VM/I386_NP21] Fix EDX value at resetting.
 * [VM/I386_NP21] Temporally enable FPU for i386.
 * [VM/I386_NP21][DEBUGGER] WIP: Adding exception handling.
 * [VM/I386_NP21] Log when made panic.
 * [VM/I386_NP21] Add undefined instruction "0F A6".
                  This may act as "int 6".Thanks to Soji Yamakawa-San.
 * [VM/I386_NP21] FPU: FISTTP INSNs (prefix DF) are only later than Pentium 4,
                  not exists I386/486/Pentium.
 * [VM/I386_NP21] Disable FPU with I386, enable with I486SX.
 * [VM/I386_NP21] Change FPUemul to DOSBOX2 (temporally).
 * [VM/I386_NP21] Initialize CR0 to 0x00000000 (+some bits) for i386.
 * [VM/I386_NP21] *Perhaps* REPNE MOVS[B|W|D] don't dedicate Z flag,
                  Thanks to Soji Yamakawa-San.
 * [VM/I386_NP21] Fix FTBFS with LLVM CLANG++.
 * [VM/I386_NP21] Add interrupt within rep prefix'ed ops.
 * [VM/UPD71071] Modify handling of 16bit transfer mode.
 * [VM/UPD71071] TOWNS_DMAC: Implement *truely* 16bit transfer feature
                             from Renesas(NEC Electronics)'s DATA SHEET.
 * [VM/UPD71071] TOWNS_DMAC: Ugly workaround for 16bit transfer DMAC command.
                             Will fix.
 * [VM/UPD71071] Change mean of TC bus bits (per channel).See mz2800.cpp.
 * [VM/UPD71071] TOWNS_DMAC: Fix mandatory name with "mask" variable/arg.
 * [VM/UPD71071] Adjust status of on-demand-mode.
 * [VM/I8253] Add debugger feature, still reading only.
 * [VM/DEBUGGER] Add "RH" command to debugger and
                 bool get_debug_regs_description(_TCHAR *, size_t) to API.
 * [VM/FMTOWNS] FONTROMS: Add API read_direct_data8() to reading faster by CRTC.
 * [VM/FM8] Fix warning from EVENT:: when resetting.
 * [VM/SCSI] Add new (pseudo) SIGNAL for preparing to use buffered transfer.
 * [Qt/LOGGER] Shrink redundant title.
 * [VM/LOGGER][OSD][VM_TEMPLATE] Add API to log with VM's time.
 * [OSD/Qt]Remove mouse position limiter.
 * [UI/Qt] Virtual media: Adjust width of "HDx:".
 * [UI/Qt] Add filename feature to Virtual-Media indicator.
 * [UI/Qt] Adjust width for HDD.
 * [UI/Qt][OSD] Add tooltip for virtual medias.
 * [UI/Qt] CDROM: Add "SWAP BYTE ORDER for AUDIO" config entry.
 * [OSD/Qt][LOGGER] Fix linkage error for LLD 10.x and Win32 cross.
 * Built with d2322eb3793c06a3056ed10245d49c6a865a79d4 (or later).

-- Jun 27, 2020 01:51:03 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT March 03, 2020
 * Upstream 2020-02-21.
 * [VM/FMTOWNS] Work initially.
                See STATUS section for doc/VMs/fmtowns.txt and
		000_gitlog.txt .
 * [VM/I386_NP21] Merge Upstream 2020-02-21 's I386::/NP21.Belows are differ from upstream:
      - Implement memory wait to change CPU speed.
      - Implement extra reset wire to notify CPU reset.
      - Some headers are changed due to cause FTBFS with GCC.
      - Character encoding chenged to UTF-8 at most of source files(not all?)
 * [VM/I386] IMPORTANT: libcpu_newdev/i386 has removed.I386:: porting from NP21 seems to be working nice, no need to porting from MAME/C++.
 * [UI/Qt] Add HARDDISK CREATION feature.
 * [VM/HARDDISK] Calculate correctness C/H/S of HDD.
 * [VM/SCSI_HDD][WIP] Implement RECALIBRATE SCSI command.
 * [VM/SCSI_HDD][VM/SCSI_DEV] Implement some command.But still not active.
 * [VM/BMJr] Fix Break sequence. Thanks to https://matsuri.5ch.net/test/read.cgi/i4004/1526806551/648 .
 * [VM/BMJr] Fix reset-key (EIKIGOU + BREAK) sequence.
 * [VM/BMJr] Alse assume Back Space key to DELETE key.
 * [VM/BMJr] Also assume Esc key to BREAK key.
 * [VM/FMGEN] Initial implemantation of YM2612 (OPN2).
 * [VM/UPD71071] Make some functions make virtual to prepare overwrap by TOWNS_DMAC.
 * [VM/DEVICE] Add update_signal_mask() to modify signal mask for SIG_SCSI_DAT for SCSI/SASI devices.
 * [VM/COMMON_VM] Include SCSI devices to libCSPcommon_vm, excepts SCSI_HOST::.
 * [VM/PCENGINE] ADPCM: Fix em-bugged freeze ADPCM DMA after CDC STATUS (write to I/O 1800h.)
 * [VM/PC9801] 86PCM: Fix Initial value of PCM_MUTE(A66Eh).Adjust volume multiply factor.
 * [BUILD/Windows] LLVM: Update Qt version to 5.14.
 * [VM/PC9801] DISPLAY: Re-Backport from Upstream 2020-02-01.Kakinoki Syougi works fine.
 * [VM/SCSI_CDROM] Fix freeze some PC-Engine's CD-ROM^2 games and SCSI HDD for FM-Towns.
 * [Qt/OpenGL_ES] Win32: Fix shader compilation errors with Angle Project.
 * [Qt/OpenGL] Correctness texture magnitude calculating.
 * [UI/Qt] Win32: Fix closing D77/D88 image when select another slot.
 * [UI/Qt] Harddisk: Add *.h0-*.h9 , they are Unz (Towns emulator)'s virtual harddisk images.
 * [OSD/SOUND] Fix crash when effective sound sink don't exists.
 * [Qt/OpenGL] Fix FTBFS if don't have libglu.
 * [UI/Qt] Add "USE_CUSTOM_SCREEN_ZOOM_FACTOR" flag to fooVM.h.
 * [UI/Qt] Try: Make GUI core (QApplication -> QCoreApplication) to be non-Global.
   Thanks to https://matsuri.5ch.net/test/read.cgi/i4004/1526806551/719 .
 * Built with fd1687a197f8e25788c8231a08e73fb3a5667763 (or later).

-- Mar 03, 2020 15:13:25 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Jan 05, 2020
 * Upstream 2019-12-31.
 * This is point release, still exists some issues (i.e.EMM386(NEC/PC98) and FreeBSD(98) don't work) for PC-9801 and PC-Engine and some VMs, will fix them.
 * [PCENGINE/CD-ROM^2] More games work.Except some games (i.e. Valis1/2).
 * [DOC] Add CrossBuild_Win32.ja.txt.
 * [VM/FM77AV] VRAM: Fix crash with opening of LUXOL.
 * [VM/FM7] DISPLAY: Simplify logic of draw_screen().
 * [VM/M5] Fix keyboard input, separate BOTH LSHIFT and RSHIFT.
           Expect to fix issue of https://matsuri.5ch.net/test/read.cgi/i4004/1526806551/617.
 * [VM/COMMON_VM] Add MEMORY:: (vm/memory.[cpp|h]) to libCSPcommon_vm.
 * [VM/COMMON_VM] MEMORY:: ; update API.
 * [VM/COMMON_VM] Include IO:: class to common_vm.
 * [VM/SCSI_DEV] Comment out duplicated writing to SIG_SCSI_DAT.
 * [VM/UPD71071] Prepare address extend for uPD71071 (for Towns).
 * [VM/UPD71071] do_dma() : Split to tiny functions.
 * [VM/SCSI_CDROM] CD-DA: Fix playing beyond multiple tracks.
              Fix freezing some CD-ROM^2 games for PC-Engine (i.e. Vails series).
 * [VM/PCENGINE] ADPCM: Add comments.
 * [VM/PCENGINE] ADPCM: Fix stopping with command 60h(REPEAT PLAY).Fix not sounding BOSS round at Valis2, but still hangs up.
 * [VM/PCENGINE] SCSI_CDROM: WIP: Fixing not play game at Valis 1.
 * [VM/I386] Reduce compiler warnings.
 * [Qt/OpenGL] Use half float textures if enabled.
 * [Qt/OpenGL] GL3: Fix using color space; yiq to ycrcb.
 * [Qt/OpenGL] GLPack:: Selective texture having (or not) ALPHA CHANNEL.
 * [Qt/OpenGL] GL4.5: Fix not capture GPU snapshot from RENDERDOC.
 * [Qt/OpenGL] GL4.5: Fix not map buffer to screen on most (not all) of emulators.
 * [Qt/OpenGL] GL4.5: Tuning around "TV Renderer".
 * [Qt/OpenGL] GL4.5: NTSC SHADER: Adjust scale factor.
 * [Qt/OpenGL] OpenGL ES: Add entry for OpenGL ES 3.1.
 * [Qt/DRAW_THREAD] New (more accurate) draw scheduler.
 * [Qt/ABOUT_DIALOG] Maybe improve credit displaying.
 * [Qt/AVIO] Replace fprintf() to logging functions.
 * [OSD/KEYBOARD] Remove some obsoleted defines.
 * Built with e327e2060d37129fed5cb150cbae8ef943fc03f8 (or later).

-- Jan 05, 2020 20:59:52 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Oct 15, 2019
  * Upstream 2019-04-30.
  * This is point release, still exists some issues (i.e.EMM386(NEC/PC98) and FreeBSD(98) don't work) for PC-9801 and PC-Engine and some VMs, will fix them.
  * [Tools] Add DUMP LIST CHECKER.
  * [BUILD/Win32] Build with LLVM CLANG (for MinGW-w64).Because GCC for MinGW-w64/Win32 has very slow exception handling (due to Borland's patent). 
  * [BUILD/Win32] See https://github.com/Artanejp/llvm-mingw and https://hub.docker.com/r/artanejp/llvm-mingw64-ubuntu-cosmic for datails.
  * [BUILD/Win32] Build against FFMpeg 4.2.
  * [FM7/SOUND] Fix reading value of PSG register(s).Fix sound of FM-7's demonstration with FM-7/77 (not with 77AV variants).
  * [FM7/SOUND] Separate reset sequence for OPN/WHG/THG/PSG to a common function.
  * [VM/FM7] Replace printf debug messages to out_debug_log().
  * [VM/FAMILYBASIC] WIP: Fix wrong string for romaji-kana (and auto key).Still imcoplete, implementing DAKUION,will fix.
  * [VM/PC9801] CPUREG: V30 SUB CPU works.
  * [VM/PC9801] Re-define DIPSW, to work with V30@PC-9801RA.
  * [VM/PC8801] Fix double install DEBUGGER:: for OPN#1,#2.Thanks to https://matsuri.5ch.net/test/read.cgi/i4004/1526806551/598 .
  * [VM/MC6809] Fix duplicate signal; SIG_CPU_HALT.
  * [VM/DEBUGGER] Fix FTBFSs with LLVM CLANG.
  * [VM/AY_3_891X] Fix pop noise when enabling lpf or hpf.
  * [VM/Z80DMA] OOPS: Disable debug spam.
  * [VM/Ix86] More correctness wait.
  * [VM/Ix86] Implement wait by memory-wait-factor.
  * [VM/Ix86] Add SIG_CPU_HALTREQ.
  * [VM/I386][VM/V30] Fix cloick handling when BUSREQ/HALT.
  * [VM/I8259] PC9801: Fix crash when changing V30 Sub CPU <-> i286/i386 Main CPU.
  * [VM/EVENT] Update comment of scheduler (EVENT::drive()).
  * [EMU/ROMAJI_KANA] Some characters are enabled to input via ROMAJI-KANA conversion.
  * [EMU/AUTOKEY]  Some characters are enabled to input via pasting from clipboard.This using UCS-4(aka UTF-32) internal format.
  * [Qt/OpenGL] Don't makeCurrent()/doneCurrent() inside of resizeGL().Fixed crash running within Docker container.
  * [UI/Qt] ROMAJI_KANA: Some characters input from KANA mode (by host) are enabled.
  * [UI/Qt] VM: Add keycode - vk - name table listing features.See vm/fm7/keyboard.cpp and qt/osd_base.h and gui/dialog_set_key.cpp.
  * [Qt/LOGGER] Threaded console logging.
  * [Qt/AVIO] Update FFMPEG's API: Revoke to use functions marked as deprecate.
  * [Qt/AVIO] Drop to use deprecated functions for FFMpeg 4.x.
  * [Qt/AVIO] Add some codec entries (still not implement).
  * [OSD/Qt] Update sound APIs: for sound sampling.Still be imcomplete.Will implement.
  * [OSD/SOUND] Simplify sound callback for SDL.
  * [OSD/SOUND] SDL: Convert sound rate/bitwidth.
  * [OSD/General] Fix not reply version of libvCSPosd.Display OSD version at "about this software".
  * [QT/MOVIE_LOADER] Fix weird initilaizing memory.
  * [Qt/MOVIE_SAVER] CONFIG: Some functions make dllexport.
  * [Qt/HOMEBREW] Fix not detected SDL at configuration of Qt::Gamepad.
  * [Qt/JOY_THREAD] Fix memory leak when plug/unplug joystick.
  * [UI/Qt] Add font selection to debugger and log view dialogs.
  * [UI/Qt] AUTO_KEY: Copy and paste: Paste even Zenkaku KATAKANA/HIRAGNA/ASCII to VM (converted to Hankaku letters).
  * [Qt/CONFIG] Keep font metrics and window size of debugger and log viewer.Save to foo.ini file.
  * [Qt/OpenGL] GLES: Fix texture format for float/half float.May work "TV RENDERER" with Win32 build (via ANGLE).
  * [Qt/OpenGL] Use half float texture for float textures to reduce GPU usage.
  * Built with 74c7914381802640510c76f176b3c3ffeceb678d (or later).

-- Oct 15, 2019 02:40:49 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Aug 16, 2019
  * Upstream 2019-04-30.
  * This is point release, still exists some issues (i.e.EMM386(NEC/PC98) and FreeBSD(98) don't work) for PC-9801 and PC-Engine and some VMs, will fix them.
  * [UI/Qt] DEBUGGER: Add history for debugger command line.
  * [UI/Qt] DEBUGGER: Add auto-completion for command-line.
  * [VM/DEVICE] Use __FASTCALL with interfaces, read_*() ,write_*(), fetch_op() and some functions.Make this faster emulation (i.e.PC-9801RA and EMM386 under FreeDOS).
  * [VM/PC9801] Separate EGC functions.
  * [VM/PC9801] Add V30@8.0MHz with some I286/I386 machines.
  * [VM/PC9801] Check differnt of system work area (0000:0400-0000:05FF) both mame(pc9801rs) and emupc9801ra .
  * [VM/PC9801] Add "UPPER_I386" flag for detect using later than HAS_I386.
  * [VM/PC9801] CPUREG: (Maybe) improve changing cpu sequence around I/O 00F0h.
  * [VM/PC9801] CPUREG: Redirect interrupt signal via CPUREG:: .VMs with V30 sub CPU (i.e.PC9801RA) work with V30.
  * [VM/PC9801] Fix wrong initialize SYS_PORT_B.
  * [VM/PC9801] Fix wrong initialize memory switch.
  * [VM/PC9801] Add DIPSWITCH object.
  * [VM/PC9801] Fix different value at [0000:0501].
  * [VM/PC9801] MEMBUS: Split update_bios() to functions.
  * [VM/FP1100] Fix lacking some key symbols.Thanks to https://matsuri.5ch.net/test/read.cgi/i4004/1526806551/540 .
  * [VM/AY_3_891X] Fix not supported defines, replace flags.
  * [VM/AY_3_891X] Add feature ; dump/set register via debugger.
  * [VM/YM2151] Add feature ; dump/set register via debugger.
  * [VM/YM2203] Add feature ; dump/set register via debugger.
  * [VM/SN74689AN] Add feature ; dump/set register via debugger.
  * [VM/BEEP] Add feature ; dump register via debugger.
  * [VM/PCM1BIT] Add feature ; dump register via debugger.
  * [VM/I80x86/V30] Start debugger even halting.
  * [VM/I80x86/8088/V30] Make i86/186/88/286 and V30 to common_vm.
  * [VM/I386] Fix WRONG flag mask at LMSW.
  * [VM/I386] MOV CR0 EyX : Fix wrong flags handling.
  * [VM/I386] Exitable when falling into infinite TRAP-Loop.
  * [VM/I386] mov CRx,R32/mov r32,CRx : Adjusting.
  * [VM/i8259] Add PIC HACKing flag for PC9801.
  * [VM/uPD7810/uPD7907] PC2001: Include uPD7810 variants and uPD7907 to libCSP_common_VM.
  * [VM/MB8877] Fix buffer overflow with logging.
  * [VM/Z80DMA] TODO/WIP: Workaround for https://tablacus.github.io/LSX-Dodgers/ .This still be not resolved issue.
  * [VM/EVENT] Add remove_context_cpu().This may not effect to MAIN_CPU(id==0).
  * [DOC/FM7] Fix typo (*ﾉω・*)てへぺろ
  * [Qt/LOGGER] Improve locking.
  * [UI/Qt] OOPs: Fix LACK of DATARECORDER BUTTONS(abolish of USE_TAPE_BUTTON): Lack of merging UPSTREAM 2018/10/07.
  * [UI/Qt] MENU: Split some methods (of Ui_MainMenuBase::) to menu_emulator.cpp and menu_machine.cpp .
  * [UI/Qt] MENU: Simplify menu creation.
  * [CONFIG/Qt] Fix bit order of logging configure.
  * [BUILD/CMAKE] Add CPU affinity mask when compiling.This may work only with GNU/Linux host.
  * [BUILD/CMAKE] Improve build message with finished.
  * [BUILD/MINGW] Update optimize parameter.
  * [BUILD] Separate definitions of archtecture flags.
  * [BUILD] Add ARM32/64 definitions (initial).Still not testing.
  * Built with 0810a8f8b9ba44cedc19bf6b8e903c9c1b5d6f04 (or later).

-- Aug 16, 2019 20:38:06 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT May 18, 2019
  * Upstream 2019-04-30.
  * [General] Add Hino Electronics CEFUCOM-21.
  * [Build/GCC] Fix FTBFS without setting LTO_THREADS value and selecting USE_LTO.
  * [Build/Linux] buildvars.dat: Add "USE_SHRINK_DEBUG_SYMBOL" flag to save disk space.
  * [COMMON] Add high pass/low pass filter function.
  * [VM/PCM1BIT,AY3_891x] Add LPF feature.See initialize_sound().
  * [VM/EVENT] Add sound sampling (from host machine) feature framework.
  * [COMMON] Add RINGBUFFER:: class, extend of FIFO::.
  * [FIFO] Add [fill|empty] warning feature.This may be useful for some devices. i.e. 16550 UART, variants of i8251.
  * [FILEIO] Add StateVector() classes.
  * [VM/DEVICE] Add CPU pseudo SIGNALS, 108 to 110.
  * [VM/COMMON] Delete unneeded __builtin_assume_aligned().MinGW32 build works built with "-msse2 -O3".
  * [VM/DMA] Add NEW signal, notify to write-changed address.
  * [VM/EVENT] Add new APIs for recording sound.
  * [VM/PC9801RA] Note: Still not running Microsoft's EMM386.EXE and FreeBSD(98).Will fix.
  * [VM/PC9801] [SASI_BIOS] Fix wrong sectors at FORMAT command.Fix run out at DOS installation.
  * [VM/PC9801] Add some DIPSWITCH features.
  * [VM/PC9801,FMR50,FMR30][SASI_BIOS] Add translate_address(segment,offset) to DEVICE:: .
  * [VM/PC9801,FMR50] Add pseudo-cycles args to  pseudo-bios for i86/286/386.
  * [VM/PC9801] Truely bootable MS-DOS 6.20,excepts EMM386.EXE.
  * [VM/PC9801][SOUND] Playable PCM of PC-9801-86.
  * [VM/PC9801][PC-9801-86] Mostly implement PC-9801-86 sound board.Touhou-Huumaroku (partly) works.
  * [VM/PC9801][MEMBUS] Remove shadow_memory, this includes ram[0xc0000]-ram[0xe7fff].
  * [VM/PC9801][MEMBUS] Maybe complete to set mapping bus to 32bit VMs except Hi-Reso.
  * [VM/PC9801][MEMBUS] Faster memory access.
  * [VM/PC9801][EGC] Make EGC faster (maybe...).
  * [VM/PC9801][CPUREG] Add ARCTIC (a.k.a Timestamp) and 0.6uS? Wait.
  * [VM/PC9801][SASI_BIOS] Improve SENSE command.Write results to 0000:0585h at INITIALIZE.
  * [VM/PC9801][DISPLAY] EGC: Add write protect register (03h).
  * [VM/PC9801][FLOPPY] Improve drive setting via 2DD <-> 2HD.
  * [VM/PC9801][MOUSE] Set clock to 120Hz when resetting.
  * [VM/PC9801] Support low resolution monitor.This is WIP.
  * [VM/PC9801][VM/I386,I286] Add variable (main) CPU clock via CPU's write_signal().Add cpu_wait_foo() with CPU_EXECUTE(foo) .
  * [VM/PC9801RA] Enable to boot contains i386 CPU with (about) correctness ITF and IPL.
  * [VM/PC9801RA] Enable EGC.
  * [VM/I386] Separate I386_OP(int) to I386_OP(int_16) and I386_OP(int_32) because pseudo bios int call (maybe 1Bh) should be in 16bit mode.
  * [VM/I386] Enable debug log (logerror()).
  * [VM/I386] Improve CALL ABS SELECTOR:OFFSET.
  * [VM/I386] Call PSEUDO-BIOS even VM86 mode, EMM386.EXE for FreeDOS(98) and VEM486 (at MS-DOS 6.2) may work(still unstable a bit).
              Some games, i.e. Touhou-KaikiDan work now.
  * [VM/I386] Faster FETCH/READ.
  * [VM/I386] Make some functions around address translation INLINE.
  * [VM/I386] Fix unexpected page fault when accessing memories.
  * [VM/I386] Try to call pseudo-bios even within protected mode (inside of i386_trap()).
  * [VM/DEVICE,I386,I286] Add total_icount via read_signal().To implement PC-9801's clock counter.
  * [VM/DEVICE] Add address_translate() API to generic devices.
  * [VM/I8237] Debug register dump: Add "BANK" registers.
  * [VM/I286][PC9801] Add SIG_I386_FORCE_RESET to notify resetting to external devices.Fix "A20 ERROR" at rebooting PC-9801(32BIT MODELS) with rebooting from program.
  * [VM/UPD7220][PC9801] Add GDC clock feature. UPD7220::set_clock_freq().
  * [VM/UPD7220] Implement position limiter for drawing (line etc).You may set gdc_foo->set_screen_width() and gdc_foo->set_screen_height().
  * [VM/UPD7220] Apply "uPD7220 Design manual".make FIFO as ring buffer.
  * [VM/UPD7220] More precision emulation.
  * [VM/UPD7220][COMMON_VM] Integrate UPD7220_BASE:: and UPD7220:: to UPD7220:: .
  * [VM/UPD7220] Fix not blink cursor.
  * [VM/UPD7220] Improve around command interpret.This makes apply *real* command-queue-empty to IO 00h:BIT2.
  * [VM/UPD7220][PC9801] Add UGLY PC98 HACK to UPD7220:: from NP2.
  * [VM/UPD7220] Update around SYNC and drawing(WIP).
  * [VM/YM2203] Fix wrong status reply at address #3.
  * [VM/MEMORY] Faster memory access.
  * [VM/MC6809][COMMON] Improve disassembler.Thanks to HASERIN-San.
  * [VM/MC6809][DISASM] Fix offset address around INDEX addressing.
  * [VM/PC9801][MEMORY] Add new API at copy_table_[r|w|rw](to, start, end).
  * [VM/PC9801][DISPLAY] Faster accessable GDC.
  * [VM/PC9801][DISPLAY] More faster VRAM access (via EGC/GRCG).
  * [VM/PC9801][SASI_BIOS] Fix status values of SASI commands.
  * [VM/LIBCPU_NEWDEV] Remove deprecated classes.
  * [BUILD/WIN32] Adjust GCC option for MinGW.
  * [QT/MENU_FLAGS] Fix TYPO.
  * [QT/EMU,OSD] Adjust emulation sequence.
  * Built with 88b18e84a6e8049da97d15ddc96d5acf30b1fcb5 (or later).

-- May 18, 2019 23:00:59 +0900 K.Ohta <whatisthis.sowhat@gmail.com>
  
* SNAPSHOT February 22, 2019
  * Upstream 2019-02-19.
  * [VM] Fix crash when end of emulation at various(!) VMs.
  * [DEBUGGER/EMU] Some functions at debugger.cpp moved (and modified) to emu.cpp. This workaround needed by libCSPcommon .
  * [EMUUTIL/WIN32] Temporally disable SSE2.
  * [VM/I8080] I8085: Fix around SID instruction.FP200 works.
  * [VM/MSM5205] Add new API: pause_w().
  * [VM/MSM5205] Adjust ADPCM's sound level due to be too small sound.
  * [VM/UPD71071] Add 16bits transfer mode (needs to emulate FM-Towns).
  * [VM/PCENGINE] Separate around ADPCM from pce.cpp.
  * [VM/PCENGINE] Mostly works CD-ROM^2 softwares, excepts (at least) Valis2 and R-TYPE. Some softwares still contain wrong working.
  * [VM/SCSI_CDROM] CDDA: Fix interpreting cue sheet.Lasersoft's brand softwares may works.
  * [VM/SCSI_CDROM] CDDA:Don't update track when setting end position.
  * [OSD/Sound] Update OSD API, initialize_sound() has 4 args, not 2.
  * [OSD/Sound] SDL_MixAudioFormat() *MUST* use for SDL2, shouldn't use SDL_MixAudio for SDL2.
  * [Qt/OpenGL] Asynchronous pixel transfer with OpenGL 4.5 (and Core profile renderer).
  * [Qt/OpenGL] Now, core profile needs less than OpenGL 4.5.
  * [Qt/OpenGL] Fix not save screenshot with OpenGL renderers.(This issue didn't happen with OpenGL ES).
  * [Qt/AVIO] Fix wrong color at one-board-computers.
  * Built with 7574bd8b47c65e32c4f4a41ec593db71cc375230 (or later).

-- February 22, 2019 04:44:44 +0900 K.Ohta <whatisthis.sowhat@gmail.com>
  
* SNAPSHOT January 13, 2019
  * Upstream 2019-01-11 .
  * [UI/Qt] OSD: Joystick-To-Keyboard: Add "1235" feature.Useful for DELPHIS (for FM-8/7) etc.
  * [UI/Qt] OSD: Apply "Joystick to Keyboard" feature.
  * [BUILD] Separate threads definition for LTO.
  * [WIN32] Update DLLS.Now using Qt5.12 and FFMpeg 4.1 and X264 157 API.
  * [VM/I386][NEWDEV] Update to upsteream.
  * [VM/PC8001] Load "FONT.ROM" as fallback, if "KANJI1.ROM" don't exists.
  * [NOTE] Now implementing FM-Towns, but still not buildable.
  * Built with c2d34b15d4c1d374e61a3ab8f66e1cca2ac926bd (or later).
  
-- January 13, 2019 01:55:36 +0900 K.Ohta <whatisthis.sowhat@gmail.com>
  
* SNAPSHOT December 18, 2018
  * Upstream 2018-12-09 .
  * [VM/PC9801] Add pseudo SASI BIOS for PC-9801.WIP.
  * [VM/EVENT] Improve error message at cancel_event().
  * [VM/HUC2680] Improve around timer.Thanks to  Ootake v2.83.
  * [VM/PCENGINE] Improve process around NEC extended command (0xd*).
  * [VM/PCENGINE] PCE_ADPCM: Fix not sound data length >= 65536 bytes.This still don't fix some softwares.i.e. Megami-Paradise.
  * [VM/PCENGINE] Porting from Ootake v2.83.This still WORK-IN-PROGRESS.
  * [VM/PCENGINE] CDROM: Don't reset ADPCM more than once at CDROM makes "NOT BUSY".
  * [VM/PCENGINE] Most of CD-ROM^2 softwares maybe work.Excepts LASERSOFT's products and using "ARCADE card".
  * [VM/SCSI_CDROM] Add write_signal() to control CDDA from MACHINE.
  * [VM/SCSI_CDROM] Fix CD-DA buffer handling.Reading buffer should be per 2352 bytes.
  * [VM/SCSI_CDROM] CUE: More correctness cue parsing.
  * [VM/SCSI_CDROM] CUE: Set default pre-gap to 2Sec (150frames).Fix audio problems of most softwares.Maybe fixed issues on Manhole.
  * [VM/SCSI_CDROM] More correctness SEEK/Interrupt timing.
  * [VM/FM7] DISPLAY: Fix for logging "[EVENT] EVENT: device (name=DISPLAY SUBSYSTEM, id=25) tries to cancel event 6 that is not its own (owned by (name=PRINTER I/F id=20))!!!"
  * [Draw/Qt] OpenGL: Abondon depth test.
  * [UI/Qt] OOPS: Fix OOPs around mounting virtual D88/D77 image(s).
  * [UI/MENU] HARDDISK: OOPS: I missed update directory.
  * [UI/MENU] Fix oops dialog of opening virtual HDD.
  * Built with ee880845ec85aa431df3c7a937611e9c20dd591d (or later).
  
-- December 18, 2018 16:31:55 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT November 24, 2018
  * Upstream 2018-11-23 .
  * [DOC] Add how to running OpenGL ES with Wine (not native Windows).See Doc/Tips_Wine.en.txt.
  * [General] Fix FTBFS with LLVM CLANG.
  * [BUILD/IA32] Build even don't use MMX, SSE and AVX.
  * [COMMON] Define some SIMD related types to common.h.Please re-define some types (__v4hi, __v8hi and __v16hi) with MSVC.
  * [COMMON] Add VRAM render common routine.This needs to initialize bit_plane_table before use.
  * [COMMON] Define decl.of alignment.Wish to fix FTBFS with Microsoft C++.
  * [VM/SCSI_CDROM] Implement *correctness* CUE parser.Mostly works fine, but lip-syncing with CDDA still not correct.
  * [VM/MB61VH010][FM77AV] More accurate busy flag implement.Don't accept drawing line if before drawing line still not end.This saves host CPU usage.
  * [VM/X1] VRAM: Apply renderer to TEXT/(P)CG rendering.
  * [VM/I386] Fix INT xxh with pseudo-bios.
  * [VM/PCENGINE] Fix around CD-ROM^2 and ADPCM.Most of softwares works.(But,lip-syncing don't well).
  * [VM/MSM5205] Use toggle switch clock.Reserve of future extend.
  * [VM/HUC6280] Fix not start debugger.
  * [VM/SCSI_CDROM] Fix around CDDA.
  * Built with b4d06ae650417feb326d304770d258b3c5fa3aaa (or later).

-- November 24, 2018 19:27:42 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT October 28, 2018
  * Upstream 2018-10-14 .
  * Update state framework to upstream, excepts scrntype_t.
  * [VM] Use namespace {VMNAME} to separate around VMs.
  * [STATE/FILEIO] Change StateValue(scrntype_t&) to StateValueScrnType_t(&) due to compiler not detect differ of scrntipe_t and (uint32_t | uint16_t);
  * [OSD/Qt] Remove some APIs.
  * [GUI/Qt] DIALOG/ABOUT:Fix not displaying version of libOSD.
  * [GENERAL] Update gitignore.
  * [MISC/TOOL] Add function extraction script.
  * [COMMON/FILEIO] common.h : Fix pair16_t and pair64_t to fileio.cpp .
  * [COMMON/FILEIO] Re-Add FILEIO::Fflush().
  * Built with 5cdfe7e27393edaecd445ac9b315d837dd697654 (or later).

-- October 28, 2018 03:36:00 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT September 30, 2018
  * Upstream 2018-09-30 .
  * [General/I18N] Update Japanese translations.
  * [FMGEN] Initial implementation of OPN2 (YM2612) from OPNA.
  * [VM/FMTOWNS] WORKING IN PROGRESS, WILL NOT BUILD due to still implement partly.
  * Built with ecf1a85f48bd98c353ea90bc3a0a49ff100b9af4 (or later).

-- September 30, 2018 17:40:12 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT August 07, 2018
  * Upstream 2018-05-24 .
  * [VM] Use VM_TEMPLATE, META-Class of VM::
  * [VM/FM7] Clear OPN/WHG/THG interrupt on resetting. Fix freeze when resetting after using RELICS.
  * [VM/FM7] DISPLAY: Not use CLR_HACK for MC6809 and delay using CLR to set busy flag.May be working MAGUS.Thanks to Anna_Wu.
  * [VM/MC6809] Remove dirty CLR insn hack.
  * [VM/DEVICE] Add DEVICE:: to libCSPcommon_vm.
  * [COMMON/Qt] Fix BYTEORDER of PIXEL@RGB888.
  * [UI/Qt][BUG] Fix crash with using LaserDisc(s).
  * [Qt/OpenGL] Initial support of OpenGL 4.3 Core profile.
  * [Qt/OpenGL] OpenGL 4.3 : Upload SCREEN using glMapBuffer().
  * [Qt/OpenGL] Use template class instead of GL2.0.
  * [UI/Qt] Separate some command line parsing to sub-routines.
  * [BUILD/WIN32] Update toolchain to Qt5.11.1.
  * [BUILD] Set SOVERSION and GIT hash automatically.
  * Built with df3888ca1199c6f75c1500dbb479d152ba6e2ad0 (or later).

-- August 07, 2018 12:53:45 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT July 13, 2018
  * Upstream 2018-05-24 .
  * [STATE] Apply new state save/load framework.See doc/a_new_state_save_load_framework.ja.txt (still only written in Japanese).
  * [STATE] Use CRC32 protection to data.
  * [STATE] Add header per devices.
  * [EMU/STATE] Enable to Gzip'ed state saving / loading.
  * [CONFIG/Bug] I forgot change top default of renderer. X-)
  * [VM/X1] Copy VRAMs to shadow data at starting a frame.Reduce flickering a lot.
  * [VM/PC9801] DISPLAY: Keep memory switch settings (saved to MEMSW.BIN).
  * [VM/I386] Remove compiler warning conversion float64 (a.k.a UINT64) <-> double.
              This still not regard when sizeof(double) != sizeof(UINT64).
  * [VM/FM7][SOUND/BEEP] Set samplerate to 6000Hz.Simplize logic.
  * [VM/DATAREC] Fix crash at removing CMT when not stopping to play.
  * [VM/DATAREC] Fix crash with MZT data.
  * [VM/NOISE] Adjust endian of WAV data.
  * [VM/NOISE] Fix infinity loop with corruptWAV data.
  * [VM/MC6809] Collect CPU statistics always, printing is controlled by menu immediately.
  * [VM/Z80] Add collecting cpu status feature for Z80.
  * [OSD/SOUND] Qt: Fix hang-up with resetting at some situations.
                Try to fix issue of http://matsuri.5ch.net/test/read.cgi/i4004/1526806551/38 .
  * [COMMON] Fix buffer overflow around strncpy().
  * [COMMON] Add pair16_t and pair64_t.
  * [COMMON] Add immediate value functions for pair_t.
  * [COMMON][VM/Qt] Add common wav-loading / saving helper functions to common.cpp .
  * [COMMON] Update min() and max().
  * [FILEIO] Add FILEIO::Fflush().
  * [FMGEN/PSG] Fix weird noise generation for SSG/PSG.
  * [FMGEN/OPNBASE] Force to calculate frequency factors around prescaler when OPNBase::LoadState().
                    Fix wrong sound after loding state.
  * [FMGEN/OPNA] Fix infinity loop at loading rhythm WAVs.
  * [FMGEN/OPNA] Adjust endian of WAV data (maybe).
  * [Qt/OpenGL] Fix buffer overflow when changing VM's screen size.
  * [Qt/Bug] Remove using_flags->get_config_ptr()->foo.
  * [Qt/MAIN] LOGGER: Fix crash on exit.
  * [Qt/LOGGER] CSP_Logger makes daughter of QObject.Add messaging slot entry.
  * [Qt/LOGGER] Use QVector insterad of QQueue to reduce CPU usage.
  * [Qt/LOGGER] Bug: Logging all devices.
  * [Qt/OpenGLES] TRY: Reduce power consumption.
  * [Qt/OpenGL] Prepare to use OpenGL 4.x (CORE).
  * [Qt/OpenGLES] Prepare to use OpenGL ES 3.1.
  * [Qt/OpenGLES] Delete condition branch in shader, use #ifdef and const values.
  * [Qt/OpenGL] Re-Add screen rotate.
  * [BUILD/CMAKE] Add "USE_SANITIZER" and "USE_STACK_PROTECTOR" entries to buildvars_foo.dat[.tmpl]
                  to detect wrong usage of variables / protect from stack overflow.
  * [BUILD/CMAKE] FM7: Not build IO::, this is not used.
  * [Qt/WIN32] Move config and logger to inner pointer, now, libCSPavio is separated to single DLL.
  * [Qt/WIN32] Move CSP_Logger to libCSPemu_utils.[foo.so|dll] from libCSPgui.[foo.so|dll] .
  * [WIN32] Update cross build script.
  * Built with 9275209c6bed03ccd06716a486e29451c446751d or later.

-- July 13, 2018 13:09:15 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT May 16, 2018
  * Upstream 2018-05-06 .
  * [EMU] Remove unneeded functions for only Qt version.
  * [Qt/OpenGL] Add OpenGL ES2 renderer.Still not display.
  * [Qt/Draw] Use Semaphore instead of mSecs waiting.Expect to improve real-time-drawing on multi thread.
  * [Qt/AVIO] Fix FTBFS with FFMPEG 4.0.Will be needed to apply to new API.Will fix.
  * [Qt/FM8] Fix number of bubble-casette: Start from 0, not 1.
  * [Qt/COMMAND_LINE] Add --opengl , --envvar and --dump-envvar .
  * [Qt/OSD] Fix around moving mouse pointer.
  * [Qt/UI] Not reset slot number when opening disk.
  * [Qt/UI] Fix around mouse problems.
  * [Build/CROSS] Add cross-compiling scripts and patch(es) to build Qt5.10.
  * [VM/MB8877] Keep command phase even changing (or removing) disk.Fix booting RELICS for FM-7 with single FDD drive.
  * [VM/MB8877] Reaset track (per drive) on reset.Fix booting RELICS for FM-7 with two FDDs.
  * [VM/MB8877] Check head loading READ/WRITE command.
  * [Win32] Built with Qt 5.10 and Angle-project's OpenGL ES2 renderer. 
  * Built with cf31c26aab576798a073e5d523bfc21b2091fd76 or later.

-- May 16, 2018 18:09:00 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Mar 26, 2018
  * [General/Qt] Add some command line options.
  * [COMMON/FM7] Add __DECL_VECTORIZE_LOOP decl. to indicate expect to use vectorize (a.k.a. SIMD instructions).
  * [VM/MB8877] Fix verify timing on SEEK command.Fix not booting Sylpheed for FM77AV.
  * [VM/MC6809] Fix clock using.
  * [VM/EVENT] Specify CPU per VM.
  * [VM/FM7] Use template and static_cast<T *> to expect to be faster.
  * [VM/FM7] Add Green display for FM-7/8/77 .
  * [VM/FM77L4] Add FM77L4.Maybe 400lines board still not working.
  * [Qt/SCREEN] Add turning on/off virtual media Icons on screen (OSD).
  * [MOVIE_LOADER] Fix scaling factor.Displaying video as correct width and height.
  * [MOVIE_LOADER] Fix hang up at end of video.
  * Built with f8f16ac6f19fe2dcab250ad50d96cf0b30c8903e or later.

-- Mar 26, 2018 01:34:20 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Mar 04, 2018
  * Upstream 2018-03-01 .
  * Thanks to Ryu Takegami and Haserin for eFM-7/77/AV/AV40/EXand eFM8.
  * [GENERAL][EMACS] Add .dir-locals.el and vs-set-c-style.el .
  *  [UI][Qt] Fix issues for ROMAJI-TO-KANA conversion.
  * [UI][Qt][DRAW] Add drawing to separate-thread or combined.
  * [UI][Qt][DEBUGGER] Fix crash/lockup with closing debugger window.
  * [UI][Qt][DEBUGGER] Remove debugger_thread.[cpp|h] due to integrate to EMU::open_debugger() and EMU::close_debugger().
  * [Qt][WINDOWS][DEBUGGER] Fix crash when exitting emulator.
  * [Qt][Windows] Prepare to parsing command line.
  * [Qt][LOGGER] Fix locale for time-string.
  * [EMU] Remove FM-7 specific hack.
  * [OSD][Qt] Fix not setting device name to logger.
  * [OSD][Qt] Use Recursive-Mutex instead of Semaphore.
  * [EMU][Qt] Use recursive mutex to lock key-in queue.
  * [UI][Qt][FM7] Add "SYNC TO HSYNC" entry also FM-7/77/8.
  * [VM][FM7] Framerate should be 55.40fps when 400line (8colors) mode.Add supporting SUPPORT_VARIABLE_TIMING.
  * [VM][FM77] Enable to boot OS-9 L1/L2 for FM-77 with 2HD FDD.Thanks to Haserin a lot.
  * [VM][FM7] Fix FRAMERATE.Fix flicking with YS2 (/AV).
  * [VM][MC6809] Fix around extra_iclock.Maybe fix around accessing wait.
  * [VM][MC6809] Fix halt sequence.
  * [VM][MC6809] Add SIG_CPU_WAIT_FACTOR. This is setting wait factor (65536 = 1wait per clock, 0 = non wait).
                 This is ugly hack due to not permited to modify clock for CPU#0 by scheduler.
                 See FM7_MAINMEM::setclock() at vm/fm7/fm7_mainmem.cpp for details.
  * [VM][MC6809] Add correcting cpu statistics per 16 frames.
  * [VM][MB61VH010] Drop unused variables.
  * [VM][MB61VH010][WIP] Adjust sequence of BUSY flag with line.
  * [VM][MB8877] READ SECTOR: MAKE IRQ and UPDATING STATUS after reading CRC bytes.This modifying needs for FM-77 using NMI as MB8877's IRQ. Thanks to Haserin.
  * [VM][MB8877] Fix seeking sequence. Thanks to Haserin.
  * [VM][MB8877] Track-verifying may be before execute command.Thanks to Ryu Takegami.
  * [VM][MB8877] Fix wait value when end of seek and verify.Thanks to Ryu Takegami.
  * [VM][FM7][MAINMEM] More accurate wait implementation.
  * [VM][FM7][KANJIROM] Fix wrong save state.
  * [VM][FM7][DISPLAY] Not use event_vline() as determine H/V SYNC.
  * [VM][FM7][DISPLAY] Use event_frame() to kick VSTART.Not loop.
  * [VM][FM7][DISPLAY] Duplicate palette (pixel) value at VSYNC.
                       Fix rendering with DRAGON BUSTER, LUXOL and more softwares.
  * [VM][FM7][DISPLAY] Stop to use OpenMP.
                       Fix display noise at 256k colors mode on Win32 Host.
  * [VM][FM77AV40EX][DISPLAY] Don't scroll at ACTIVE_PAGE != 0.
  * [VM][FM7][KEYBOARD] Make  interupt handling at reset correctness.
                        Fix hang-up resetting after checking keyboard interrupt at mainio.
  * [VM][FM7][KEYBOARD] Fix initial key code value.
  * [VM][FM77][2HD] BREAK KEY AND ATTENTION MUST BE MASK IF FIRQ USING FOR FDC's DRQ.Thanks to Haserin.
  * [VM][PYUTA] PYUTA has no state save/load.
  * Built with 7c0c0657f8f726e7aa86ace64777036e1cca4ce4 and later.

-- Mar 04, 2018 11:22:02 +0900 K.Ohta <whatisthis.sowhat@gmail.com>
    
* SNAPSHOT Feb 16, 2018 FM7 TEST1
  * Upstream 2017-12-27 .
  * This is test release. Will re-write articles in this entry to next official release.
  * [VM] Add eFMNEW7.
  * [VM/FM7][UI/FM7] MAINMEM: Re-order bank of bulk BOOTROMs.Thanks to HASERIN.
                     IMPORTANT: Re-order boot entries within MENU dynamically.
		                This is compatibility with older settings.
				GUI's menu (for eFM8/eFMNEW7/eFM7*) must change order of boor menu entry.
  * [VM/FM77]   Add ON/OFF extra RAM.
  * [VM/FM77AV] Add to use dictionary board for FM77AV/20/EX.
  * [VM/FM77] BUG: I mistaken to connect motor line for 2HD FDD, I connected 2D FDD (；´Д｀)
  * [VM/FM77] 2HD: Fix DRQ->FIRQ handling.Wish to BOOT 2HD OSs.
  * [VM/FM77AV] DISPLAY: Do not reset interrupt masks at reset on sub-system.Thanks to Ryu Takegami.
  * [VM/FM77AV] MAINMEM: More simple inside structure for PAGE2.
  * [VM/FM8] Change default frequency to 1.0MHz.Thanks to Haserin.
  * [VM/FM8] Fix RS232C #1(COM0:) can't remove from maim board.Thanks to Haserin.
  * [VM/FM7/JCOMMCARD] Use bulk rom (or DICTIONARY + KANJI) for DICTIONARY ROM AREA.
  * [VM/FM7/JCOMMCARD] Abndon use JIS78 emulation.
  * [VM/FM7/KANJIROM] Abndon use JIS78 emulation.
  * [VM/BUBBLECASETTE] Improve status register.Thanks to Haserin and Ryu Takegami.
  * Special thanks to Ryu Takegami, to assist debugging FM-7/77/AV/40/EX/8 .
  * Special thanks to Haserin, to assist debugging FM-7/77.AV/40/EX/8.
  * Built with commit bc517f5638b4f5612cc075e0f4d9278220eab4fc or later.

-- Feb 16, 2018 06:02:49 +0900 K.Ohta <whatisthis.sowhat@gmail.com>
    
* SNAPSHOT Feb 11, 2018
  * Upstream 2017-12-27 .
  * [CONFIG] IMPORTANT: Now, "~/emufoo/" moved to "~/CommonSourceCodeProject/emufoo/"
	                (or ".\CommonSourceCodeProject\emufoo\" ).
             Please move settings to here.
  * [CONFIG] IMPORTANT: Now, "~/emufoo/foo.ini" has moved to "~/.config/CommonSourceCodeProject/emufoo/"
	                      (or ".\CommonSourceCodeProject\emufoo\ at Windows").
             Please move ini and scancode.conf to new place.
  * [VM/MB8877] Enable to boot FLEX/FM-8.
                Thanks to https://matsuri.5ch.net/test/read.cgi/i4004/1483504365/800- .
  * [UI/Qt] Add option: Emulate cursor keys as "2468" or "1235".
  * [UI/KEYBOARD] Add option, "Numpad's Enter is Fullkey's".Useful for FM-77AV series, etc.
  * [UI/VM] MB8877/T3444/uPD765A: Add ON/OFF debug logging for FDCs.
  * [Qt/EMU] Seriarize queueing both KEY_DOWN and KEY_UP.
             Expect to fix  key-in issues with slower host machine.
	     See https://matsuri.5ch.net/test/read.cgi/i4004/1483504365/841 .
  * [UI/Qt] BUG: Fix crash with BOOT_MODEs >= 8.
  * [UI/Qt] FM7: Extend boot menu.
  * [UI/KEYBOARD] Update VM table.
  * [UI/KEYBOARD] Fix load/save sequence of scancode.cfg.
  * [UI/Qt] Update translate for menu.Split section per menu-bar-entry.
  * [MENU/Qt] DISK: Fix not affect of some entries:"Correct disk timing","Ignore CRC error" and "Immediate transfer".
  * [Draw/OpenGL] FM77AV: Fix blinking with some situation.
  * [VM/MC6809] Fix around CWAI with interrupts.
  * [VM/MC6809] Make set/reset E flag at interrupt.
  * [VM/MC6809] More accurate emulation(maybe).
  * [VM/MC6809] Fix clock count with some situation, FM-8/7/77/AV don't need dummycpu.
  * [VM/FM7] Remove DUMMY CPU.Reduce host-cpu usage a lot.
             Related to commit a4e1a7cfef59e08f31675c6608871068d3f2c4ef.
  * [EMU/FM7] emu.cpp : No longer use hack with some VMs.
  * [VM/FM7] KEYBOARD: Keep BREAK key when special reset (hot start).
  * [VM/FM7] MAINIO: Reduce hitting PCM1BIT:: when not sound buzzer.
  * [VM/FM7] DISK: Fix RPM value of 2D/2DD drive to 300rpm.
  * [VM/FM7] Read some (bulk) roms for FM-8/7/NEW7/77.This is WORK-IN-PROGRESS.
  * [VM/FM8/FM77] Add delay FIRQ/NMI from 2HD/SFD FDC.This is temporally implement.
  * [VM/FM8] MAINIO: Move FM-8 specified features to FM8_MAINIO:: .
  * [VM/FM77] Add initial support of 2HD (for FM-77).
  * [VM/FM77] Fix access around BOOT-RAM.Thanks to Ryu Takegami.
  * [VM/FM77] Extra memories should start $00000, not $10000.Thanks to Ryu Takegami.
  * [VM/FM77] Fix wrong answer at $FD04.Thanks to Ryu Takegami.
  * [VM/FM77AV] DISPLAY: Separate event process around VSYNC/HSYNC.
  * [VM/FM77AV40] Fix FTBFS with Fedora linux.
  * [VM/FM77AV40EX] Do not effect offset registers to VRAM-ACTIVE-BLOCK 1.Thanks to Ryu Takegami.
  * [VM/MB8877] No need to hack with PSY-O-BLADE for FM77AV.This is test delete.
  * [VM/MB8877] Force down DRQ when LOST-DATA happens.
  * [VM/MB8877] Fix not read status data at the endof SEEK and verifying.
  * [VM/MB8877] Update structure of MB8877->fdc.
  * [VM/MB8877] Try: Improbe result quality of FORCE_INTERRUPT command.
                 I expect to boot OS-9 Level1 for FM-77 with 2HD drive.Thanks to Haserin-san.
  * [VM/DISK] Fix default value ignore_crc_error and correct_disk_timing (mostly "to false").
  * [DOC] Add README.md (written in Japanese) and README.en.md (written in English) for GITHUB's cover page.
  * Special thanks to Ryu Takegami, to assist debugging FM-7/77/AV/40/EX/8 .
  * Special thanks to Haserin, to assist debugging FM-7/77.AV/40/EX/8.
  * Built with commit 221fcef002f101b8dffd2a63edfc11a86e2c688a or later.

-- Feb 11, 2018 02:29:55 +0900 K.Ohta <whatisthis.sowhat@gmail.com>


* SNAPSHOT Jan 19 2018
  * Upstream 2017-12-27 .
  * [EMU] Add set_vm_screen_lines(int lines) to notify changing vertical resolution
        to OSD and Hardware-Renderer(for scan lines). See vm/fm7/display.cpp .
  * [VM] Add EMU::set_vm_screen_lines() to some VMs.
  * [UI/Qt] Add "Click On Focus" feature option.This don't need to mouse-over to input from keyboard if set.
  * [VM/FM7] Add Japanese communication board (日本語通信カード) .
  * [VM/FM7] Add turning ON/OFF Z80 extra board.
  * [VM/FM7] Add UARTs.RS-232C, MODEM and MIDI.Temporally implements.
  * [FM7/JCOMMCARD] Add test program.Use asl ( http://john.ccac.rwth-aachen.de:8000/as/ ) to make from source code.
  * [VM/FM7] Use #define to define name of firmwares.
  * [VM/FM7] KANJIROM: Add JIS78 patch mode.From XM7 3.4L77a.
  * [VM/MB8877] Not clear status when force-interrupt with TYPE-1 Command(seek etc).
                Fix (Add hack) for FUKU*.d77 (えびふく's music disks for FM-7).
  * [VM/MB8877] Fix DRQ/IRQ timing.
  * [VM/MB8877] Make IRQ with disk not inserted or not connected when processing command(s).
  * [VM/MB8877] Make turning ON IRQ and turn OFF DRQ when seek completed.
  * [VM/MB8877] Adjust track parameter at initialize and CMD::RESTORE .
  * [VM/MB8877] OS-9 Level2 for FM77AV40 Works.
  * [VM/HD6844] FM77AV40EX has only one DMA channel.Not multiple channels.
  * [VM/HD6844] HD6844 has only a one interrupt line, not multiple.
  * [VM/HD6844] Rename drq_line to busreq_line.
  * Special thanks to Ryu Takegami, to assist debugging FM-7/77/AV/40/EX .
  * Built with commit 9376345bc1270e2a76db816636b645e744d09e82  or later.

-- Jan 19, 2018 01:49:25 +0900 K.Ohta <whatisthis.sowhat@gmail.com>


* SNAPSHOT Jan 04 2018
  * Upstream 2017-12-28 .
  * [Qt/FM-7] Windows: Fix not effect keyin with "\_" for *native* Windows.
  * [RES/FM7] Fix drive number:Should not start from "FD1", should start from "FD0" for FM7/8 series.
  * [VM/MC6809] More accurate emulation around interrupt.
  * [VM/FM7] Z80: Implement interrupt features.
  * [VM/FM7] Merge Ryu Takegami's fixes.
  * [FM7/DISPLAY] Fix around KANJI ROM access flag by sub system.Expect to fix OS-9 L2 for AV40.
  * [FM7/DISPLAY] Fix display flag on reset.
  * [FM7/MAINMEM] Fix clock parameter with some situation.Thanks to Ryu Takegami.
  * [VM/MB8877] Fix freezing with OS-9 with 2DD drive/image.Thanks to Ryu Takegami.
  * [Qt/DEBUGGER] Not push empty string.
  * [BUILD] Read from templete if config (buildvars.dat etc) has not exists.
  * [VM] common.h : Not has <typeinfo.h> excepts VC++.Recommend to use <typeinfo> .
  * [BUILD/CMake] GNU/Linux: Add fallback LIB directory feature for library installation.
-- Jan 04, 2018 11:59:54 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Dec 10, 2017
  * Z80 Card with FM-8/7/77 Series test.
  * This release package is only with some VMs.
  * [VM/FM7] Initial support of extra Z80 card.
  * [VM/MC6809] More accurate emulation around HALT/BUSREQ and INT.
  * [VM/MC6809] You should'nt use bus_halt, use bus_ba (bus available) and bus_bs (bus status).
  * [VM/MC6809] Split interrupt sequence, to indicate bs bus as interrupt or sync_in.
  * Built with commit c15048ee4635d4413887c2b8374a488a566e63cb or later.
  
-- Dec 10, 2017 19:55:30 +0900 K.Ohta <whatisthis.sowhat@gmail.com>
  
* SNAPSHOT Dec 04, 2017
  * Upstream 2017-12-03.
  * [VM/MC6809] Fixing hangup with F-BASIC v3.0ε.Thanks to Ryu Takegami-San. 
                (see https://matsuri.5ch.net/test/read.cgi/i4004/1483504365/641-645)
  * [VM/FM7] DISPLAY: Implement software scan line(s).
  * [VM/FM77AV] VRAM: More use SIMD to be faster.
    [VM/FM7] Try: Add suuporting for OPpenMP.But be slower than not using OpenMP (/_;)
  * Build with commit 9eb246b375699752a898d8be79a227f58e473d8e (or later).

-- Dec 04, 2017 19:29:05 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Oct 18, 2017
  * Upstream 2017-08-12.
  * [VM/FM7] FLOPPY: Fix crash when starting.
  * [Build/CMAKE] Fix FTBFS with USE_COMMON_DEVICE_LIB != "Yes".
  * [Build/WIN32] MinGW: Add new cross-build script for FFMPEG-3.4 and x264-152.
  * [Build/Linux] Add "COMPRESS_SYMBOLS" flag to configuration.
  * [BUILD/Linux] Don't use LTO for shared libs, use compress symbols.
  * [BUILD] Fix FTBFSs a lot.
  * [DOC] Rename LICENSE to LICENSE.txt due to coflict to doc/license directory.This is important to release for M$ Windoze OS.

-- Oct 18, 2017 16:33:58 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Aug 11, 2017
  * Upstream 2017-08-10.
  * [EMU/ROMAKANA] Fix not convert with Qt.Use functions within EMU:: , not use original ROMAKANA functions.
  * [VM] Add PC-9801RA and PC-9801VX.
  * [VM] Add devices to libCSPcommon_vm mostly.
  * [VM] Fix FTBFS and bugs a lot.
  * [VM/FM7] Stop using DUMMYDEVICE:: . Use VM::get_extra_leds() to get led status.
  * [VM/MB8877] DISK:Fix not apply workaround to Gambler Jiko Chusin-ha for FM-7 series.
  * [VM/DATAREC] Fix crash with MZT data.
  * [Qt/UI] OpenGL: Display ICONs when accessing to virtual medias.
  * [Qt/UI]  Separate status bar display:Accessing to virtual medias.
  * [Qt/UI] Menu: Make macro to be easier constructing.
  * [Qt/UI] Ui_MainWindowBase:: Make private variables/functions not accessed from Ui_MainWindow:: .
  * [Qt/UI] Display LEDs with USE_EXTRA_LEDS or USE_KEY_LOCKED.See common/emu_thread.cpp for details.
  * [Qt/UI] Fix some memory leaks.
  * [Qt/OpenGL] Fix aspect ratio with some zoom type.
  * [Qt/FM7] Fix wrong scaling at VMs (only FM-8/7/77/AV) has only 200line (not have 400line). 
  * [BUILD/CMake] CCACHE: Fix SEGFAULT at linking after upgrade GNU toolchain.
  * Build with 04e08d2708a595c518ae0bd92c1713e1854c4310 (or later).

-- Aug 11, 2017 23:38:49 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT HOTFIX1 May 18, 2017
  * MSX FIX only release.
  * [VM/MSX] I missed changes; using v9938.cpp instead of v99x8.cpp .
  * [BUILD] Add comments to buildvars*.dat.tmpl .
  * [BUILD/Ubunts16.04LTS][V9938] Fix internal compiler error with gcc-5.
  * Build with 2d337bdf6eb8a168efa1e219d81bb007da5e9d65 (or later).

-- May 18, 2017 19:13:23 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT May 18, 2017
  * Upstream 2017-05-15
  * [General] Rename "emumsx2plus" -> "emumsx2p".
  * [UI/Qt] Fix unconnected event.
  * [UI/Qt] I forgot to add a "*.gz" extension to opening of Cartridges, CDs and Binaries.
  * [OSD/Qt] Add *_features_* functions. It needs for *NEW* device emulation.Pls. port to win32/ .
  * [EMU][Qt][MOUSE] Fix not effect with button-up.
  * [VM] LibCSPcommon_vm : Without #ifdef.
  * [VM] LibCSPcommon_vm : Add some devices.See src/vm/common_vm/CmakeLists.txt .
  * [VM] Fix FTBFSs with LLVM (4.0).
  * [VM/MC6809] Build shared library without libnewdev/. Use vm/mc6809.cpp and vm/mc6809_debugup.cpp . See, fm7.cpp.
  * [VM/FM7] Faster address transferring.
  * [VM/DEVICE] You should add "DECVICE::initialize()" to top of initialize().
  * [VM/DEVICE] Move some devices to shared lib.
  * [VM/DEVICE] Split MSM5832:: from MSM58321:: .
  * [VM/M6502] Split M6502 to N2A03 and M6502.
  * [VM/MB61VH010] Expect to be faster rendering.
  * [VM/MB61VH010][FM77AV] Re-order addrsss of read_data8() and write_data8(). You must re-build some VMs (FM77AV series etc.)
  * [CONFIG] Fix over loop.
  * Build with 8067b89f01c21ee29c1b4bb4af8e7c112f88577c or later.

-- May 17, 2017 22:52:55 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT April 09, 2017
  * Upstream 2017-04-02
  * [General] Add National JR-800.
  * [UI/Qt] Move drive status from status-bar to right dock.
  * [FILEIO] Fix FTBFS with ZLIB 1.2.8 or earlier.
  * [VM/General] EMU/COMMON : Fix bugs around handling filename and directories.
  * [VM/General] common.cpp : Use buffer sized functions for some string functions.
  * [VM/FM77AV] DISPLAY: HSYNC:Don't register event(s) per HDISP.
  * [VM/FM7] DISPLAY: Reduce address calculation.
  * [VM/FM7] DISPLAY: Fix auto skip feature.
  * [VM/FM7] Use function table(s) to access memories within display sub-system and main-system.
  * [VM/FM77AV40EX] Fix wrong display timing.
  * [Build/CMake] Add supporting for ZLIB.
  * [BUILD/LINUX] Fix linking order.
  * [General/BUILD] Linux: Use -D_UNICODE to build.

-- Apr 09, 2017 23:04:45 +0900 K.Ohta <whatisthis.sowhat@gmail.com>
  
* SNAPSHOT March 07, 2017
  * Upstream 2017-03-04
  * [VM] Some devices have prepared to move to libCSPcommon_vm .
  * [VM/FMGEN] Move FMGEN to libCSPfmgen .
  * [WIN32] Ready to build with DLLs contain GUI and AVIO and some features.
  * [BUILD] Selectable building.
  * [BUILD] Add logging build-status.
  * [Qt] Fix break device files when exiting emulator with some situations.
  * [Win32/OpenGL/WIP] TRY: Fixing crash with OpenGL3.0 at Corei5-2420M (and Windows7) PC. See Issues.txt or Issues.ja.txt.
  * [DOC] Update Issues.See http://hanabi.2ch.net/test/read.cgi/i4004/1483504365/30 .
  * [EMU/DEBUGGER] Use pthread_t instead of SDL_Thread.
  * [Qt/OSD] Remove do_call_debugger_command().
  * [SOUND/VM] Fix choppy sounds with some devices. i.e. PCM1BIT. Thanks to Takeda-San and Umaiboux-San.
  * [VM/FMGEN] Fix crash with GCC-5.This is issue of optimization, add "volatile" to any member(s).
  * [BUILD/LINUX] GCC5: (MAYBE) Enable to set "USE_RADICAL_OPTIMIZE" to "YES".
  * Built with 2dac70eb1743e2a0b778a57a1f520fce59aa6371 or newer.

-- Mar 07, 2017 15:55:25 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT January 30, 2017
  * Upstream 2016-12-31
  * [VM/SOUND] Fix problems voice with PCM (at least MSX and FM-7(Reviver)).
               See http://hanabi.2ch.net/test/read.cgi/i4004/1483504365/37 .
. * [VM/MB8877] Fix accessing 2D disk from 2DD mode drive (not 2D mode).
                Fixed booting issue of REVIVER for FM-7/77/AV with FM77AV40/EX/SX.
  * [Draw/Qt] Fix wrong aspect when using variable screen size.i.e.)emufm7/emufm77av40ex.
  * [UI/OpenGL] Add selection of draw infrastracture; OpenGLv3(MAIN) and OpenGLv2 (and OpenGLv3.2(Core): Still not implemented).
  * [Qt/OpenGL] Fix backgrounds not display at one-board-computer drawing with OpenGLv2.
  * [Qt/LOG] Enable syslog *truely*.
  * Built with cef2d4601438fd1fa680485ddba3434690e58451 or newer.

-- Jan 30, 2017 05:04:55 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT January 24, 2017
  * Upstream 2016-12-31
  * [UI/Qt] Add tooltips to menu entries mostly.
  * [UI/Qt] Add Japanese translations to menu entries mostly.
  * [SOUND] Add "Strict Rendering" entry to sound menu, for PCM1BIT device.
  * [VM/FM7] Fix crash without connecting FDDs.
  * [VM/UPD7752] Fix (´∀｀)＜ぬるぽ sometimes.
  * [DRAW/FM7] Fix wrong screen aspect on VMs without variable lines.
  * [Build/Linux] Fix scripts.
  * [Build/Linux] Fix crash built with gcc-5 (or earlier). Fixed for Ubuntu16.04LTS.
  * [Build/Linux] Separate builds both Debian/sid and Ubuntu/16.04LTS (expects to work with Debian/stable).
  * Built with 6e93d6920626193bf37fa6dfc2f41a8e84d8fd78 or newer.

-- Jan 24, 2017 01:06:26 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT January 06, 2017
  * Upstream 2016-12-31
  * Add Coleco Colecovision and SHARP SM-B-80TE (from upstreeam).
  * [FM7] Reduce graphic buffer for non-400 lines machines.
  * [WIN32/Qt] Cross-Build Qt libs: disable EGLFS (not EGL).
  * [Qt] One board computers: Read correctly background PNG even using indexed colors.
  * [Qt/GL] One board computers: Correctness drawing with GL3.0.
  * Built with 9bfdcc78ff194a934a2d57ce6d4f1cbec9f26a58 or newer.

-- Jan 06, 2017 19:56:37 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT November 21, 2016
  * Upstream 2016-04-13
  * [Linux] Build with Qt 5.5.1 . Abondon Qt 5.3 (If you need, build with your Qt or use binary of qt.io build version.)
  * [OpenGL] Add Television like rendering to some machines. Needs OpenGL3.0 or upper.
  * [OpenGL] Isolate both GL3.0 and GL2.0.
  * [OpenGL] Improve internal of GLDraw and GLDraw_foo class.
  * Built with 73358d8563543f1a0d860794a2f5c83cecb0d533 or newer.

-- Nov 21, 2016 16:29:24 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT October 27, 2016
  * Upstream 2016-04-13
  * [GENERAL] Add ROMAJI-KANA input assistant feature. see romakana.[en|ja].txt .
  * [VM/SOUND] Fix wrong rendering period for PCM1BIT with some VMs.  Maybe fixed issue of http://hanabi.2ch.net/test/read.cgi/i4004/1430836648/775 .
  * [VM/EVENT] Re-entrant set_realtime_render().
  * Built with FFMPEG(libav) 3.1.5 .
  * Built with 006cc1d851483ea84fc5a3f4fa58cbf03302c49b or later.

-- Oct 27, 2016 17:01:21 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT October 18, 2016
  * Upstream 2016-04-13
  * [VM/EVENT] Sound devices: Do mix_sound() dynamically, not do per a sample:
  *            To reduce usage of host CPU. See event.[cpp|h] and device.h .
  * [VM/FM7] Non-FM77AV*: Fix not clear active_page, fixed crash randomly.
  * Built with 004920711399d430ead55e59c948e7fb7a04a402 or later.

-- Oct 18, 2016 11:22:05 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT October 10, 2016
  * Upstream 2016-04-13
  * [VM] Add pseudo sounds (i.e. FDD seek), need sound files (even not WAV file at Qt porting), see doc/VMs/foo.txt . 
  * [VM][DATAREC][FDCs] Update STATE_VERSION of some devices.
  * [VM/FM7] VRAM: Make gcc using SIMD (when optimize options have set) to be faster rendering.
  * [VM/X1,FM7] load_state(): Keep backward compatibility to SNAPSHOT 20160923.
  * [VM/EVENT] Extend permitted sound events to 32 to use sound files (reserved feature).
  * [VM/EVENT] Update MAX_SOUND from 8 to 16.
  * [Qt/GUI] Win32: Fix crash launching with gdb/Mingw32 or gdb/Cygwin. See http://hanabi.2ch.net/test/read.cgi/i4004/1430836648/750 .
  * [Build/Linux] Fix wrong flags with LTO.
  * [Build] Non-Win32 : Ready to build with llvm clang (later than 3.7?).
  * [Build/GENERAL] Separate compiler depended params to source/build-cmake/param/ .
  * Build with commit d100ae8323d6657fe37ac44a69abc8da470b77ad (or later).

-- Oct 10, 2016 05:22:18 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT September 23, 2016
  * Upstream 2016-04-13
  * [DOC] Translated some documents written in Japanese only to English using Google-Translate, still not enaugh to be corrected.
  * [Qt/WIN32] Fix crash on startup (maybe true) caused by (´∀｀)＜ぬるぽ　ヽ(・∀・)ノ┌┛ガッΣ(ノ｀Д´)ノ
  * [VM] Add original name and role to all device and VM components.
  * [VM/FM7] JOYSTICK: Fix not redirect triggers.
  * [VM/FM7][MB8877/DISK] Workaround for RIGLAS/FM-7. Perhaps, below have side-effect, add special-disk to RIGLAS FM.
  ** Don't "NOT READY" even stopping motor.
  ** Transfer even stopping motor.
  * [EVENT] Remove logging on cancel event.
  * [Qt/Debugger] Not hang-up when Opening debugger and exit emu{foo}. This is temporally workaround.
  * [Qt/Debugger] Don't close with close button, this is temporally workaround.
  * [UI/Qt] Fix selecting printers.
  * [VM/PC9801] Add prepairation of using ITF ROM, this is still only preparation.
  * Built with GIT 8cdb1dbebf95d7371e514886c23edc6c9401848a (or later).

-- Sep 23, 2016 19:48:12 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT September 09, 2016
  * Upstream 2016-04-13
  * [LOGGER] Add extend logger.
  * [LOGGER/Qt] Rename agar_logger.[cpp|h] to csp_logger.[cpp|h] .
  * [VM] Ready to enable log per device.
  * [VM] Update emu->out_debug_log to [DEVICE]->out_debug_log .
  * [UI/Qt] Add log viewer window.
  * [Qt/EMUTHREAD] Move commonly blocks to gui/ .
  * [Qt/KEY] Use queue for keyin/out.
  * [VM/OSD] Add socket (networking) featuers, but still not test (；´Д｀)
  * [VM/FM77AV] MB61VH010 : Faster drawing lines.
  * [VM/FM7] MAINIO: Comment out logging around FIRQ, temporally.
  * [OSD/KEYBOARD] Fix handling around SHIFT for some machines(i.e. PC8801).
  * [MOVIE_SAVER] Use SIMD to transfer a picture OSD(VM)->MOVIE_SAVER .
  * [DOC] Update updtream's URL, moved to takeda-toshiya.my.coocan.jp .
  * Built with GIT 1884b5247665d71c06fc6590b17434c5f3350ad5 (or later).

-- Sep 09, 2016 01:02:51 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT August 19, 2016
  * Upstream 2016-04-13
  * [WIN32] Replace libICU to homebrew, fix not starting.
  * [OSD/MOVIE_SAVER] Fix frames to enqueue to MOVIUE_SAVER, as if VIDEO FPS >= RECORD FPS.
  * [MOVIE_LOADER] Sync A/V on playing MOVIE.
  * Built with GIT 77380a77b25ca06965b912c84509e5c91085aeb1 (or later) .

-- Aug 19, 2016 23:12:36 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT August 15, 2016
  * Upstream 2016-04-13
  * [OSD][MOVIE_SAVER] Maybe correctness frame(s) counting with 60fps ヽ(=´▽=)ﾉ
  * [MOVIE_SAVER] Fix sometimes crashing when stop to save movie.
  * [PX7/MOVIE_LOADER] Sound Laser Disc, but not be smooth.
  * [MOVIE_SAVER][PC8801][PC9801] Adjust sound frequency when OVERRIDE_48000Hz , still choppy.
  * Built with GIT 3f4c809912dc92cdeb34d8ecdebe0087aa7f37b3 (or later) .
 
-- Aug 16, 2016 02:40:55 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT August 09, 2016
  * Upstream 2016-04-13
  * [PX7] Add movie loader for LD, but not tested enough yet.
  * [MOVIE_SAVER/OpenGL] Add locking around drawing buffer.
  * [BUILD] Update FFMPEG to 3.1.1 .
  * [FFMPEG/LINUX] Enable OpenCL for ffmpeg @linux.You need libOpenCL.so.1 to use homebrew build.
  * [FFMPEG/WIN32] Enable DXVA2 for video-decoding accelerator.
  * [MOVIE_SAVER] Synchronous OPEN->ENCODEING->CLOSING.
  * [UI/MOVIE_SAVER] DO NOT change state of "Save as movie" without *real* starting/stopping.
  * [Draw/OpenGL] Optimize GLSL's by https://github.com/aras-p/glsl-optimizer .
  * Built with GIT fc7a03a9337287414e00777464ab273c4f44ea44 (or later) .
 
-- Aug 10, 2016 01:42:51 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT July 25, 2016
  * Upstream 2016-04-13
  * Bugfix only.
  * [Win32] Build with Qt5.7.0 and GCC-6.1 (cross).
  * [MOVIE_SAVER/OSD] Fix wrong framerate when recording ; this is related by frame skipping. Maybe fixed (3) of http://hanabi.2ch.net/test/read.cgi/i4004/1430836648/705
  * [MOVIE_SAVER/Qt] Fix duplicate opening before closing. Maybe fixed (5) of http://hanabi.2ch.net/test/read.cgi/i4004/1430836648/708 .
  * Build with 8265a0a859ac69ef7c17548851902eab2de6f7f4 (or later).
  
-- Jul 25, 2016 21:59:41 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT June 29, 2016
  * Upstream 2016-04-13
  * Build with FFMPEG 3.0.2 supported libmp3lame.
  * [MOVIE_SAVER/Win32] Fix wrong value of left frames for audio when stopping to record.
  * [OSD/Qt] Fix wrong FPS with not drawing.
  * Build with 3752c12b4b08f9910f3e3b6ad6f7dfbd76342cbb (or later).
  
-- Jun 29, 2016 13:05:15 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT June 21, 2016
  * Upstream 2016-04-13
  * Build with FFMPEG 3.0.2 supported libmp3lame.
  * [Linux] Build with qt.io's official Qt 5.3.1 expect to work with 
    Ubuntu 16.04 LTS and Debian 8 "Jessie".
  * [MOVIE_SAVER] (Maybe mostly?) Fix asynchronous both video and audio.
  * [MOVIE_SAVER] Add libmp3lame and vorbis (disable from UI) for audio codec.
  * [Qt] Not linking config and using_flags directly from libCSPgui , libCSPavio and libCSPosd .
  * [MOVIE_SAVER][EMU] Fix stop/restart recording movie when changing/ejecting CARTRIDGEs.
                       Now, don't stop when changing/eject cartridge.
    See, http://hanabi.2ch.net/test/read.cgi/i4004/1430836648/699 .
  * [MOVIE_SAVER] Re-enable (and selectable) H.264 for video codec.
  * Build with 85c331b7635ca713e819218b86d65a877b7478f3 (or later).
  
-- Jun 21, 2016 01:07:44 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT June 18, 2016
  * Upstream 2016-04-13 .
  * Build with FFMPEG 3.0.2 .
  * [MOVIE_SAVER] More safer open/close.
  * [MOVIE_SAVER] Fix deadlock when closing movie.
  * [MOVIE_SAVER] Selectable both MPEG4v1 and H.264(libx264) for video codec.
  * [MOVIE_SAVER][Qt] Temporally set video-codec to MPEG4 (not AVC).
    This is issue of discard frames with libx264 by ffmpeg's libavcodec/libavformat.
    This seems to be ffmpeg's issue, not my program.
  * Build with 629f7d70816c04b38c3ab8cc277147a6bd2c2d2a (or later).
  
-- Jun 18, 2016 03:32:06 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT June 11, 2016
  * Upstream 2016-04-13 .
  * Use osdn.jp to distibute binaries.
    https://osdn.jp/projects/csp-qt .
  * [MOVIE_SAVER] Use ffmpeg internal aac codec, because faac or fdk_aac are not *Free* .
  * [VM/MOVIE_SAVER] Fix stopping when changing cartridge, now refer to upstream (split movies).
  * [Qt/Win32] Fix not work with WindowsXP, using homebrew version of ffmpeg-2.8.7.
  * Build with 89d31ce8daa733ea4a0c38f0a1890d3a0fcfce38 (or later).
  
-- Jun 11, 2016 05:09:55 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT June 09, 2016
  * Upstream 2016-04-13 .
  * Now, all of binaries are built with ffmpeg-2.8.7 at GNU/Linux,  with ffmpeg-3.0 at Windows.
  * Please read README.ffmpeg.txt .
  * [FM7/Disk] Add exceptions for Xanadu Scenario 2, this has not booted with changes 49dceaca9401d3c6037cb51ec013ca032ff0e83c .
  * Build with 64df71cd492be91289f883224640f42cace090ed (or later).

-- Jun 09, 2016 05:50:50 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT June 08, 2016
  * Upstream 2016-04-13 .
  * Add movie saver, using libav with x264.
  * Now, all of binaries are built with ffmpeg-3.0.
  * Build with 2142d5c7426e21cfeedbaea0450f238f8b4d7d38 (or later).

-- Jun 08, 2016 07:34:45 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT May 23-2, 2016
  * Win32 binary only RELEASE
  * Fix unable to run with some natibve Windows environment.
  * Build with c1448dc84f5439c7c8931614a8397dbefb6383da .

-- May 24, 2016 22:42:00 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT May 23, 2016
  * Upstream 2016-04-13 .
  * [Win32] Now built with -msse -msse2 . You can run only later than Pentium4 .
  * Move FILEIO:: FIFO:: COMMON:: to libCSPemu_utils .
  * Make OSD:: to inherited by OSD_BASE:: .
  * [Win32] Disable LINKFLAGS with "-static-libgcc -static-libstdc++" to reduce size of executions, now, bundled libstc++ is for gcc-5 .
  * [Win32/Build] Support build with MSYS2 (but not display because MSYS2's Qt was build without OpenGL).
  * [Linux] Build shared libraries with Link-Time-Optimize, reduce size of libs.
  * [X1/VM] Configurable buttons for X1/Turbo/Turbo Z.
  * [FM7/FDC] Set MB8877_NO_BUSY_AFTER_SEEK. Fixed unable to boot OS0. Thanks to Anna_Wu.
  * [FM77AV/MB61VH010] ALULINE: Reduce CPU usage (at delta X > delta Y).
  * [UI/Qt/DRAW] Fix crash sometimes when exit emulator.
  * Build with 1c1ddc85dfa7456b1ce48662c2e2930dcc4fc9d8 (or later).

-- May 23, 2016 02:22:07 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT May 11, 2016
  * Merge upstream 2016-04-13 .
  * Move more files to libCSPgui , includes FILEIO, FIFO, COMMON, draw_thread , joy_thread and main().
  * Now SONAME of libCSPgui to 1.1.x .
  * [FM77AV/MB61VH010] Fix bugs within ALULINE now, Sylpheed and demonstration of FM77AV (not AV40) works fine.
  * [FM7/KEYBOARD] Add auto stop key (using 8 or 5).
  * [FM77AV/KEYBOARD] Add hidden buzzer and features for AMNORK.
  * [FM8] Fix not booting from floppy, thanks to Anna_Wu.
  * [FM7/FM8] Add "Connect 320KB FDD" 
     You should check this at first when using FDDs.
  * [FM77AV/DISPLAY] Move sequence copying vram to shadow-vram ; from HBLANK to HDISP .
  * [FM77AV/MB61VH010] Reduce overhead.
  * [FM7/DISPLAY] Reduce line transfer / rendering.
  
-- May 11, 2016 12:18:17 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Apr 28,2016
  * Merge upstream 2016-04-13 .
  * [General] Fix save/load state.
  * [General] Build with GCC6 for GNU/Linux .
  * [General] Build with "-g -O3 -fvect-cost-model=dynamic -ftree-vectorize",
    not with "-g -Og" .
  * [FM77AV] Fix not repeating with scan key mode, fixed YS2. 
  * [FM7/Display] VRAM: Fix positioning of wrote line .
  * [FM77AV/Display] Fix "Sync to HSYNC", mostly has no filckerings.
  * [FM7/Display] Fix rendering algorythm (to be better rendering quality).
  * [FM77AV40/Display] Qt: Fix variable resolution ; wrong display (not VM) size with resetting.
    i.e:) When resetting with 4096 colors mode, height of display was half size (to display, but within VM, right size). 
  * [FM77AV/Keyboard] Fix lockup some situations.
  * [Qt/Sound] Fix wrong balance and volume after re-starting.
    i.e:) With 0db and panning to right, and re-starting, volume and balance hasn't kept.

-- Apr 28, 2016 01:53:55 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Apr 09, 2016
  * Merge upstream 2016-04-01 .
  * [General] Add upstream newbie VMs: YALKY, PC-2001 and SMC-70.
  * [*nix] Separate UI component to shared lib named libCSPgui (and re-factor src/qt/gui and src/qt/common .
  * [BUILD/GCC] Compile with -O3 for libCSPgui .
  * [*nix] Add a installer script.
  * Note: [VM][FM7][WIP] Fix still not working some software without re-construct VMs at FM-7/NEW7/77.
  * Built with commit 3297e37e10c8b57a1bd0378b55ccd6eccd6d82b9.

-- Apr 09, 2016 00:16:14 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Mar 25, 2016
  * Merge upstream 2016-03-17 .
  * [FM7] Fix some weird works (i.e: not booting DEATH-Force) without construct VM twice, now construct VM a time.
  * [UI/PCENGINE] Add support CD-ROM^2 (but not tested yet, I don't have any image).
  * [VM/MB8877] Probe some status via read_signal().
  * [BUILD/GCC] Use -Og instead of -O3.
  * [UI/MZ3500/HC80/QC10] Fix not set dip-switches.
  * [UI/JOYSTICK] Support Label of buttons.
  * [UI] Add supporting printers with more VMs.
  * [UI/MZ80] Enable select PCG-800/1200.
  * [UI/MZ700] Enable select PCG-700.
  * [VM/FMGEN] PSG: Fix volumes are not independed via another PSG/SSG devices. Thanks to umaiboux.
               See: http://hanabi.2ch.net/test/read.cgi/i4004/1430836648/576
  * [VM/FM-8] Add support Bubble Casette, this is not complete implement , but seems to work.
  * Built with commit 34fb5d731eccd3601a7587657ccb1eb22404045b.

-- Mar 25, 2016 13:26:17 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Mar 11, 2016
  * "Pray for all people injured by Great East Japan Earthquake"
  * Merge upstream 2016-03-05. Fix some FTBFSs with SCSI and FMR30/50.
  * [Menu/Qt] Fix some unification spells at menu, thanks to Anna_Wu.
  * [UI/Qt] Add icons a lot, from mate-icon-theme source package @
    mate-desktop.org.
  * [UI/Qt] Working "Paste from clipboard" with CR/LF.
    Thanks to http://hanabi.2ch.net/test/read.cgi/i4004/1430836648/528 .
  * [Win32] Fix character encoding at logging. Thanks to
    Thanks to http://hanabi.2ch.net/test/read.cgi/i4004/1430836648/528,530 .
  * [Qt/Sound] Update sound volume setting dialog.
  * [Qt/BMJr] Fix not input some keys with Qt.
  * [FM7] Detect 太陽の神殿 for FM-7 series to correct transfer
    timing automatically.
  * [VM/FM7] Fix some software has not booted, need to (destruct and)
    re-construct VM class before loading. See constructor of emu.cpp .
  * Fix bugs a bit.
  * Built with commit cc9a6b95d3ee6765a3b9d8befe9243a1522032ac or later.
 
-- Mar 11, 2016 04:56:20 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Mar 04, 2016
  * Merge upstream 2016-03-01. Applying new APIs.
  * [FM8] Fix wrong sequence of selecting BOOT ROMS when reading/writing $FD0F,
    Thanks for Anna_Wu .
  * [UI/Qt] Re-Working "Paste from clipboard", apply to new APIs.
  * [UI/Qt] Fix character encoding of config file 
            when not using UTF-8 as local encoding.
  * [General] Enable to build with LLVM Clang at least 3.7. Another
              versions are not tested yet.
  * More usable dialog for setting sound volumes.
  * Fix debugger a bit.
  * Built with commit 2fc557e88d2715f5fda328ecf38af4b81714b81e or later.
 
-- Mar 04, 2016 22:56:53 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Feb 26, 2016 HOTFIX 1
  * [FM7/77/8] Fix reset sequence of PSG/OPN/WHG/THG.
    This fixes lower tone of PSG with FM-7/77.
  * Built with commit 2e87abcb02cee28532215484517d999b561817a3 + .

-- Feb 27, 2016 01:37:13 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Feb 26, 2016
  * Merge upstream 2016-02-26.
  * Windows: Fix wrond key conversion from SCAN to VK.
  * Enable to build within native Windows host with MinGW.
  * Debugger: Fix weird command interpreting.
  * FM7: Fix wrong key assigning.
  * FM7/6809: Fix wrond debugger APIs.
  * Help Menu: Add FAQs and about settings of BIOS and Key assigns.
  * Add documentation how to build.
  * Built with commit 82115ccfbcd6c8493933e518779c1d7f70940c9f or later .

-- Feb 27, 2016 00:13:09 +0900 K.Ohta <whatisthis.sowhat@gmail.com>
	
* SNAPSHOT Feb 25, 2016
  * Merge UPSTREAM 2016-02-21.
  * Support NEW APIs.
  * Qt: Add dialogs: Key definition and Joystick Definition.
  * FM7: Add support printers; Dumb printer and Dempa Shimbun-sha's Joystick.
  * FM7: A lot of changes.
  * Qt: A lot of changes.
  * Built with commit f59a7c8a03b357a16d4b33e5a5e5fef2591cdfc2 or later .

-- Feb 25, 2016 06:53:28 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Jan 24, 2016
  * Qt/OpenGL: Draw even not ready to GL3.0, fallback to GL2.0 (with/without shaders).
  * Qt/OpenGL: Display screen even with VirtualBox and Host of linux , excepts Ubuntu 14.04 LTS.
               GL libraries for Ubuntu 14.04 LTS seem to be weird (excepts AMD/nVidia's proprietary GLs).
  * FM7: Fix around clock setting.
  * FM7: Fix crash sometimes on initializing.
  * Sound: Fix crash with some VMs.
  * Sound: Fix choppy sound.
  * Sound: Fix not effected sound-latency settings.
  * Built with commit f6248ec7dfa76e776eddcb0e685fbf6b7ff58b65 .

-- Jan 24, 2016 13:44:50 +0900 K.Ohta <whatisthis.sowhat@gmail.com>
	
* SNAPSHOT Jan 19, 2016-1
  * Merge upstream 2016-01-10.
  * Qt/OpenGL: Reduce GPU usage a lot. Save energy.
  * Qt/OpenGL: You should use OpenGL >= v3.0 .
  * Use printer: MZ1P17 to any VMs.
  * FM8 : implemented. But not test enough.
  * FM7: Fix incorrectness reset sequence around of keyboard when resetting.
  * FM7: Adjust draw timing.
  * FM-8/7/NEW7 : Removable kanji rom.
  * FM7: Some of Fixes.
  * Qt/OpenGL: Re-enable 4:3 CRT mode.
  * Built with commit eced83faa808f2fde47a24365ebe4a6656aa40fb .

-- Jan 19, 2016 14:50:50 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Jan 07, 2016-3
  * Hotfix for 2016-01-07 and 2016-01-07-2.
  * SOUND: Fix broken WAV data of recording sound.
  * Built with commit 8708a53b6627eba226d1bce0ba89bf792d884c98 .

-- Jan 08, 2016 12:19:19 +0900 K.Ohta <whatisthis.sowhat@gmail.com>
	
* SNAPSHOT Jan 07, 2016 -2
  * Fix crash of a lot of VMs.
  * Built with commit e0b53fc1bd4af3a232ccc878671bab2caf7743f8 .

-- Jan 07, 2016 23:08:35 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Dec 22, 2015
  * MERGE upstream 2015-12-17, support new APIs .
  * Change APIs to upstream's OSD class , apply to Qt.
  * Mostly built for Win32.
  * FM-7/NEW7: Fix a lot of bugs.
  * FM7 series: Variable virtual screen size, see src/vm/fm7/display.cpp .
  * X1 series: Double buffering for TEXT/PCG.
  * Built with commit 24709b7e0ffdd2714266c487465cc4b37208aace .
    excepts PASOPIA7, PC-6601SR and PC-8001mk2SR are built with 
    commit daddbc5ac974be890f545d0a0cd68730fdce154f.
    and Z80 TV GAME have built with 
    commit 956581bd7f969f36d5146018ea19297fa5cd9db0 .

-- Dec 22, 2015 18:22:09 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Dec 10, 2015
  * MERGE upstream 2015-12-10 .
  * Change APIs to upstream's OSD class , apply to Qt.
  * Still not built for Win32.
  * Built with 3fe6eddaeb7d6b2ba2c69a06e8cdc05acac690f2 ,
    excepts eTK80BS for 79e5e48043a64b6b74257fe3a9fc20e80b0e2252.
  
-- Dec 10, 2015 19:18:05 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Nov 20, 2015
  * MERGE upstream 2015-11-18 .
  * Remove original definition min() max() if supplied from toolchain. 
  * Qt: (MAYBE) Working with Windows XP, but not tested enough to.
  * Fixed typos.
  * Built with commit 4b3f3a7e4c007c1f4da62b64ceed8821fa239575 and newer Documents.
  
-- Nov 20, 2015 01:08:28 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Nov 17, 2015
  * Qt: (MAYBE) Working with Windows XP, but not tested enough to.
  * Qt: Working Auto key (paste from clipboard) feature.
  * Qt/Emu: More thread-safety calling via UI <-> EMU.
  * VM/MSX2: Fix wrong color built with Qt.
  * Update credits, thanks to umaiboux San.
  * Built with commit 64f901722d3382bc3feb6680a5ede240dcad2773 and newer Documents.
    Excepts HC-20/40/80, with commit a249e76d9bd77e42e45ec066e6c063498c6600bd.
  
-- Nov 18, 2015 02:01:48 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Nov 14. 2015
  * Qt/GUI: Integrate menus to meta-class.
  * Win32/Qt: Enable to build with MinGW32 and Qt 5.5.1, please test!!!
  * Built with commit 910b3cce215964380fa3dbe38fbb673c52bf4d34 excepts with newer documents.
  * A lot of fixes.
  
-- Nov 14, 2015 20:12:24 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Nov 05. 2015
  * Merged Upstream 2015-10-31 , thanks for Takeda-San.
  * Qt: Change Draw method from QOpenGLFunctions_2_0 to QOpenGLFunctions, expect to work with OpenGL ES 2.0, without OpenGL.
  * FM7: Fix problem of LSHIFT and RSHIFT.
  * Qt: Add OpenGL rendereded scan line.
  * OpenGL: Use GLSL to rendering.
  * Win32/Qt: Enable to build with MinGW32 and Qt 5.5.1, please test!!!
  
  * Built with commit b166b5c2ca66457baf348b7fe55c55d63028e609 excepts with newer documents.
  
-- Nov 05, 2015 22:35:05 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Oct 29, 2015
  * Merged Upstream 2015-10-27.
  * All of virtual machines are enabled to build.
  * FM7/77/AV/40/EX : Mostly working.
  * FM7 : Add state saving.
  * FM7 series: More a lot of fixes, most of softwares are working well, please test and report to me.
  
  * Built with commit d3d19e4157290b1869ac6bf98e788e9a13fbe164 excepts with newer Documents.  

-- Oct 29, 2015 17:40:35 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Sep 26, 2015
  * Merged Upstream 2015-09-03.
  * Add FM77AV40/EX , Basic Master Jr and Jr-100.
  * FM7 : Add DMA(HD6844) and others.
  * FM77AV : Add hidden message within keyboard encoder.
  * FM7 series: A lot of fixes, most of softwares are working well, please test and report to me.
  * Built with commit 031b72db4243f0fd62c1c2556a4ceb9934da1121 .  

-- Sep 26, 2015 02:38:29 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Aug 11, 2015
  * FM-7/77/AV series only SNAPSHOT build.
  * FM7 : Faster VM: Maybe useful running with lower clock/less cores CPU.
  * MC6809 : More accurate determining clocks.
  * UI/Qt : Fix some OOPs. 
  * Built with commit 5ac4478df3ebef9461c4748cd605c72da54aad2b .

-- Aug 11, 2015 13:34:20 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Aug 10, 2015
  * Merged Upstream 2015-08-09.
    To know details : history.txt .
  * DISK/MB8877 : Fix not booting from write protected disk image.
  * DISK/MB8877 : Search sector : Track in ID field  must be equal to track register.
  * MB8877 : Improbe emulation accuracy (Thanks Takeda-San).
  * Win32 : Fix crash when foo.ini exists and using in *real* 
            Windows XP (Thanks Anna Wu).
  * Qt : Fix segfault when exiting.
  * Qt/SDL : Fix lockup with one CPU environment (maybe OK).
  * Qt : Fix abnormal exit when exiting from window-manager.
  
  * Built with GIT mcommit 6b432ad5d5c8d32cf7da5237c233773d95b1ac7a .
-- Aug 10, 2015 15:04:20 +0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Aug 07, 2015
  * Merged Upstream 2015-08-07.
    To know details : history.txt .
  * DISK : Remove "Hack:Fast transfer" item from menu items. 
  * Built with GIT commit 6a36e02989161ade9242111da520eb28a4dddd66 .
  * Win32/VS2015 : Now don't use "Whole-Program-Optimization".
-- Aug 08, 2015 03:39:15 + 0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Aug 01, 2015
  * Merged Upstream 2015-08-01.
    To know details : history.txt .
  * DISK : Remove "Hack:Fast transfer" item from menu items. 
  * Built with GIT commit 197cc999d496b3071bef21f1a64f01ae6b9b1180 .
  * Add YS6464a and Z80 TV Game.
-- Aug 02, 2015 21:00:03 + 0900 K.Ohta <whatisthis.sowhat@gmail.com>


* SNAPSHOT Jul 31, 2015
  * Merged Upstream 2015-07-31.
  * FM77AV : Fix not working with some softwares.
  * DISK : Add "Hack:Fast transfer", useful for some 
    softwares majoring speed of FDD, i.e."ぎゃんぶらぁ自己中心派" for FM7.
  * FM7 : Add stereo sounds, volume per OPN/WHG/THG card.
  * FM7 : Fix polling time of keyboard to 20ms, workaround of
          some softwares i.e."Nobunaga no yabou Zenkokuban" for FM77AV.
  * And many of VMs are added to Win32.
  * Built with GIT commit  1a974b38e96bf93804f6fcaceafd9136e985bf01 .
-- Aug 01, 2015 04:13:13 + 0900 K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Jul 26,2015
  * FM77AV: Fix dropping data from keyboard encoder using
            REALTIME-Scanning mode.
  * FM7: Fix break key issues.
  * FM7: Fix not write VRAM when not cycle-steal &&  vram_access
         flag is not ON.
  * MZ1500 / Win32 : Fix weird by7teorder for font drawing.
  * Built with GIT commit b06d4becba032444eed2ee1736b519856960a2fc . 
  
-- K.Ohta <whatisthis.sowhat@gmail.com>

* SNAPSHOT Jul 25,2015

  * First SNAPSHOT release for Common Source Code Project with Qt, FM-7.
  * Based on upstream: 2015-06-28 .
  * Built with GIT commit 69504d38060aae6551b589581e46056edc6d256e .
-- K.Ohta <whatisthis.sowhat@gmail.com>
  
